#!/usr/bin/python
import cgi
import commands
import os
import string

stats = {
    1:['load_average', 'Load averages'],
    2:['cpu','CPU usage'],
    3:['netxfer','Network throughput'],
    4:['memory','Memory usage']
    }

utility_nodes = {
    1:'fcdfhead1',
    2:'fcdfhead2',
    3:'fcdfmon1',
    4:'fcdfcode1',
    5:'fcdflnx1',
    6:'fcdflnx2',
    7:'fcdflnx3'
    }

servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata007',  8:'fcdfdata008',
     9:'fcdfdata009', 10:'fcdfdata010', 11:'fcdfdata011', 12:'fcdfdata012',
    13:'fcdfdata013', 14:'fcdfdata014', 15:'fcdfdata015', 16:'fcdfdata016',
    17:'fcdfdata017', 18:'fcdfdata018', 19:'fcdfdata019', 20:'fcdfdata020',
    21:'fcdfdata021', 22:'fcdfdata022', 23:'fcdfdata023', 24:'fcdfdata024',
    25:'fcdfdata025', 26:'fcdfdata026', 27:'fcdfdata027', 28:'fcdfdata028',
    29:'fcdfdata029', 30:'fcdfdata030', 31:'fcdfdata031', 32:'fcdfdata032',
    33:'fcdfdata033', 34:'fcdfdata034', 35:'fcdfdata035', 36:'fcdfdata036',
    37:'fcdfdata037', 38:'fcdfdata038', 39:'fcdfdata039', 40:'fcdfdata040',
    41:'fcdfdata041', 42:'fcdfdata042', 43:'fcdfdata043', 44:'fcdfdata044',
    45:'fcdfdata045', 46:'fcdfdata046', 47:'fcdfdata047', 48:'fcdfdata048',
    49:'fcdfdata049', 50:'fcdfdata050', 51:'fcdfdata051', 52:'fcdfdata052',
    53:'fcdfdata053', 54:'fcdfdata054', 55:'fcdfdata055', 56:'fcdfdata056',
    57:'fcdfdata057', 58:'fcdfdata058', 59:'fcdfdata059', 60:'fcdfdata060',
    61:'fcdfdata061', 62:'fcdfdata062', 63:'fcdfdata063', 64:'fcdfdata064',
    65:'fcdfdata065', 66:'fcdfdata066', 67:'fcdfdata067', 68:'fcdfdata068',
    69:'fcdfdata069', 70:'fcdfdata070', 71:'fcdfdata071', 72:'fcdfdata072',
    73:'fcdfdata073', 74:'fcdfdata074', 75:'fcdfdata075', 76:'fcdfdata076',
    77:'fcdfdata077', 78:'fcdfdata078', 79:'fcdfdata079', 80:'fcdfdata080',
    81:'fcdfdata081', 82:'fcdfdata082', 83:'fcdfdata083', 84:'fcdfdata084',
    85:'fcdfdata085', 86:'fcdfdata086', 87:'fcdfdata087', 88:'fcdfdata088',
    89:'fcdfdata089', 90:'fcdfdata090', 91:'fcdfdata091', 92:'fcdfdata092'
    }

worker_nodes = {
      1:'fcdfcaf001',   2:'fcdfcaf002',   3:'fcdfcaf003',   4:'fcdfcaf004',
      5:'fcdfcaf005',   6:'fcdfcaf006',   7:'fcdfcaf007',   8:'fcdfcaf008',
      9:'fcdfcaf009',  10:'fcdfcaf010',  11:'fcdfcaf011',  12:'fcdfcaf012',
     13:'fcdfcaf013',  14:'fcdfcaf014',  15:'fcdfcaf015',  16:'fcdfcaf016',
     17:'fcdfcaf017',  18:'fcdfcaf018',  19:'fcdfcaf019',  20:'fcdfcaf020',
     21:'fcdfcaf021',  22:'fcdfcaf022',  23:'fcdfcaf023',  24:'fcdfcaf024',
     25:'fcdfcaf025',  26:'fcdfcaf026',  27:'fcdfcaf027',  28:'fcdfcaf028',
     29:'fcdfcaf029',  30:'fcdfcaf030',  31:'fcdfcaf031',  32:'fcdfcaf032',
     33:'fcdfcaf033',  34:'fcdfcaf034',  35:'fcdfcaf035',  36:'fcdfcaf036',
     37:'fcdfcaf037',  38:'fcdfcaf038',  39:'fcdfcaf039',  40:'fcdfcaf040',
     41:'fcdfcaf041',  42:'fcdfcaf042',  43:'fcdfcaf043',  44:'fcdfcaf044',
     45:'fcdfcaf045',  46:'fcdfcaf046',  47:'fcdfcaf047',  48:'fcdfcaf048',
     49:'fcdfcaf049',  50:'fcdfcaf050',  51:'fcdfcaf051',  52:'fcdfcaf052',
     53:'fcdfcaf053',  54:'fcdfcaf054',  55:'fcdfcaf055',  56:'fcdfcaf056',
     57:'fcdfcaf057',  58:'fcdfcaf058',  59:'fcdfcaf059',  60:'fcdfcaf060',
     61:'fcdfcaf061',  62:'fcdfcaf062',  63:'fcdfcaf063',  64:'fcdfcaf064',
     65:'fcdfcaf065',  66:'fcdfcaf066',  67:'fcdfcaf067',
     68:'fcdfcaf068',  69:'fcdfcaf069',  70:'fcdfcaf070',  71:'fcdfcaf071', 
     72:'fcdfcaf072',  73:'fcdfcaf073',  74:'fcdfcaf074',  75:'fcdfcaf075', 
     76:'fcdfcaf076',  77:'fcdfcaf077',  78:'fcdfcaf078',  79:'fcdfcaf079', 
     80:'fcdfcaf080',  81:'fcdfcaf081',  82:'fcdfcaf082',  83:'fcdfcaf083', 
     84:'fcdfcaf084',  85:'fcdfcaf085',  86:'fcdfcaf086',  87:'fcdfcaf087', 
     88:'fcdfcaf088',  89:'fcdfcaf089',  90:'fcdfcaf090',  91:'fcdfcaf091', 
     92:'fcdfcaf092',  93:'fcdfcaf093',  94:'fcdfcaf094',  95:'fcdfcaf095', 
     96:'fcdfcaf096',  97:'fcdfcaf097',  98:'fcdfcaf098',  99:'fcdfcaf099', 
    100:'fcdfcaf100', 101:'fcdfcaf101', 102:'fcdfcaf102', 103:'fcdfcaf103', 
    104:'fcdfcaf104', 105:'fcdfcaf105', 106:'fcdfcaf106', 107:'fcdfcaf107', 
    108:'fcdfcaf108', 109:'fcdfcaf109', 110:'fcdfcaf110', 111:'fcdfcaf111', 
    112:'fcdfcaf112', 113:'fcdfcaf113', 114:'fcdfcaf114', 115:'fcdfcaf115', 
    116:'fcdfcaf116', 117:'fcdfcaf117', 118:'fcdfcaf118', 119:'fcdfcaf119', 
    120:'fcdfcaf120', 121:'fcdfcaf121', 122:'fcdfcaf122', 123:'fcdfcaf123', 
    124:'fcdfcaf124', 125:'fcdfcaf125', 126:'fcdfcaf126', 127:'fcdfcaf127', 
    128:'fcdfcaf128', 129:'fcdfcaf129', 130:'fcdfcaf130', 131:'fcdfcaf131', 
    132:'fcdfcaf132', 133:'fcdfcaf133', 134:'fcdfcaf134', 135:'fcdfcaf135', 
    136:'fcdfcaf136', 137:'fcdfcaf137', 138:'fcdfcaf138', 139:'fcdfcaf139', 
    140:'fcdfcaf140', 141:'fcdfcaf141', 142:'fcdfcaf142', 143:'fcdfcaf143', 
    144:'fcdfcaf144', 145:'fcdfcaf145', 146:'fcdfcaf146', 147:'fcdfcaf147', 
    148:'fcdfcaf148', 149:'fcdfcaf149', 150:'fcdfcaf150', 151:'fcdfcaf151', 
    152:'fcdfcaf152', 153:'fcdfcaf153', 154:'fcdfcaf154', 155:'fcdfcaf155', 
    156:'fcdfcaf156', 157:'fcdfcaf157', 158:'fcdfcaf158', 159:'fcdfcaf159', 
    160:'fcdfcaf160', 161:'fcdfcaf161', 162:'fcdfcaf162', 163:'fcdfcaf163', 
    164:'fcdfcaf164', 165:'fcdfcaf165', 166:'fcdfcaf166', 167:'fcdfcaf167', 
    168:'fcdfcaf168', 169:'fcdfcaf169', 170:'fcdfcaf170', 171:'fcdfcaf171', 
    172:'fcdfcaf172', 173:'fcdfcaf173', 174:'fcdfcaf174', 175:'fcdfcaf175', 
    176:'fcdfcaf176', 177:'fcdfcaf177', 178:'fcdfcaf178', 179:'fcdfcaf179', 
    180:'fcdfcaf180', 181:'fcdfcaf181', 182:'fcdfcaf182', 183:'fcdfcaf183', 
    184:'fcdfcaf184', 185:'fcdfcaf185', 186:'fcdfcaf186', 187:'fcdfcaf187', 
    188:'fcdfcaf188', 189:'fcdfcaf189', 190:'fcdfcaf190', 191:'fcdfcaf191', 
    192:'fcdfcaf192', 193:'fcdfcaf193', 194:'fcdfcaf194', 195:'fcdfcaf195', 
    196:'fcdfcaf196', 197:'fcdfcaf197', 198:'fcdfcaf198', 199:'fcdfcaf199',
    200:'fcdfcaf200', 201:'fcdfcaf201', 202:'fcdfcaf202', 203:'fcdfcaf203',
    204:'fcdfcaf204', 205:'fcdfcaf205', 206:'fcdfcaf206', 207:'fcdfcaf207',
    208:'fcdfcaf208', 209:'fcdfcaf209', 210:'fcdfcaf210', 211:'fcdfcaf211',
    212:'fcdfcaf212', 213:'fcdfcaf213', 214:'fcdfcaf214', 215:'fcdfcaf215',
    216:'fcdfcaf216', 217:'fcdfcaf217', 218:'fcdfcaf218', 219:'fcdfcaf219',
    220:'fcdfcaf220', 221:'fcdfcaf221', 222:'fcdfcaf222', 223:'fcdfcaf223',
    224:'fcdfcaf224', 225:'fcdfcaf225', 226:'fcdfcaf226', 227:'fcdfcaf227',
    228:'fcdfcaf228', 229:'fcdfcaf229', 230:'fcdfcaf230', 231:'fcdfcaf231',
    232:'fcdfcaf232', 233:'fcdfcaf233', 234:'fcdfcaf234', 235:'fcdfcaf235',
    236:'fcdfcaf236', 237:'fcdfcaf237', 238:'fcdfcaf238', 239:'fcdfcaf239',
    240:'fcdfcaf240', 241:'fcdfcaf241', 242:'fcdfcaf242', 243:'fcdfcaf243',
    244:'fcdfcaf244', 245:'fcdfcaf245', 246:'fcdfcaf246', 247:'fcdfcaf247',
    248:'fcdfcaf248', 249:'fcdfcaf249', 250:'fcdfcaf250', 251:'fcdfcaf251',
    252:'fcdfcaf252', 253:'fcdfcaf253', 254:'fcdfcaf254', 255:'fcdfcaf255',
    256:'fcdfcaf256', 257:'fcdfcaf257', 258:'fcdfcaf258', 259:'fcdfcaf259',
    260:'fcdfcaf260', 261:'fcdfcaf261', 262:'fcdfcaf262', 263:'fcdfcaf263',
    264:'fcdfcaf264', 265:'fcdfcaf265', 266:'fcdfcaf266', 267:'fcdfcaf267',
    268:'fcdfcaf268', 269:'fcdfcaf269', 270:'fcdfcaf270', 271:'fcdfcaf271',
    272:'fcdfcaf272', 273:'fcdfcaf273', 274:'fcdfcaf274', 275:'fcdfcaf275',
    276:'fcdfcaf276', 277:'fcdfcaf277', 278:'fcdfcaf278', 279:'fcdfcaf279',
    280:'fcdfcaf280', 281:'fcdfcaf281', 282:'fcdfcaf282', 283:'fcdfcaf283',
    284:'fcdfcaf284', 285:'fcdfcaf285', 286:'fcdfcaf286', 287:'fcdfcaf287',
    288:'fcdfcaf288', 289:'fcdfcaf289', 290:'fcdfcaf290', 291:'fcdfcaf291',
    292:'fcdfcaf292', 293:'fcdfcaf293', 294:'fcdfcaf294', 295:'fcdfcaf295',
    296:'fcdfcaf296', 297:'fcdfcaf297', 298:'fcdfcaf298', 299:'fcdfcaf299',
    300:'fcdfcaf300', 301:'fcdfcaf301', 302:'fcdfcaf302', 303:'fcdfcaf303',
    304:'fcdfcaf304', 305:'fcdfcaf305'
      }

node_description = {

'fcdfdata001':'Static',
'fcdfdata002':'Static',
'fcdfdata003':'Static',
'fcdfdata004':'Static',
'fcdfdata005':'Static',
'fcdfdata006':'Static',
'fcdfdata007':'FTP: General icaf/scratch',
'fcdfdata008':'dCache pool',
'fcdfdata009':'dCache',
'fcdfdata010':'dCache',
'fcdfdata011':'dCache',
'fcdfdata012':'DB tests',
'fcdfdata013':'spare',
'fcdfdata014':'FTP: INFN',
'fcdfdata015':'Static',
'fcdfdata016':'SAM',
'fcdfdata017':'dCache',
'fcdfdata018':'dCache',
'fcdfdata019':'dCache',
'fcdfdata020':'dCache',
'fcdfdata021':'dCache',
'fcdfdata022':'dCache',
'fcdfdata023':'dCache',
'fcdfdata024':'dCache',
'fcdfdata025':'FTP: JHU',
'fcdfdata026':'FTP: INFN',
'fcdfdata027':'FTP: Florida',
'fcdfdata028':'FTP: UCDavis',
'fcdfdata029':'FTP: Harvard',
'fcdfdata030':'FTP: Duke',
'fcdfdata031':'FTP: Toronto',
'fcdfdata032':'FTP: UK',
'fcdfdata033':'on loan to Sloan DSS',
'fcdfdata034':'on loan to Sloan DSS',
'fcdfdata035':'dCache',
'fcdfdata036':'dCache',
'fcdfdata037':'dCache',
'fcdfdata038':'dCache',
'fcdfdata039':'dCache',
'fcdfdata040':'dCache',
'fcdfdata041':'FTP: Geneva',
'fcdfdata042':'FTP: Japan',
'fcdfdata043':'FTP: Cantabria',
'fcdfdata044':'FTP: INFN',
'fcdfdata045':'FTP: INFN',
'fcdfdata046':'FTP: Japan',
'fcdfdata047':'FTP: Penn',
'fcdfdata048':'FTP: Yale/Korea',
'fcdfdata049':'FTP: Purdue',
'fcdfdata050':'FTP: UIUC',
'fcdfdata051':'FTP: MIT',
'fcdfdata052':'dCache',
'fcdfdata053':'dCache',
'fcdfdata054':'dCache',
'fcdfdata055':'dCache',
'fcdfdata056':'dCache',
'fcdfdata057':'dCache',
'fcdfdata058':'dCache',
'fcdfdata059':'dCache',
'fcdfdata060':'dCache',
'fcdfdata061':'dCache',
'fcdfdata062':'dCache',
'fcdfdata063':'dCache',
'fcdfdata064':'dCache',
'fcdfdata065':'dCache',
'fcdfdata066':'dCache',
'fcdfdata067':'dCache',
'fcdfdata068':'dCache',
'fcdfdata069':'dCache',
'fcdfdata070':'dCache',
'fcdfdata071':'dCache',
'fcdfdata072':'dCache',
'fcdfdata073':'dCache',
'fcdfdata074':'dCache',
'fcdfdata075':'dCache',
'fcdfdata076':'Static',
'fcdfdata077':'Static',
'fcdfdata078':'Static',
'fcdfdata079':'Static',
'fcdfdata080':'Static',
'fcdfdata081':'Static',
'fcdfdata082':'Static',
'fcdfdata083':'Static',
'fcdfdata084':'Static',
'fcdfdata085':'Static',
'fcdfdata086':'Static',
'fcdfdata087':'Static',
'fcdfdata088':'Static',
'fcdfdata089':'FTP: Japan',
'fcdfdata090':'FTP: Japan',
'fcdfdata091':'FTP: Japan',
'fcdfdata092':'FTP: UK',

'fcdfcaf001':'Stage 1 test',
'fcdfcaf002':'',
'fcdfcaf003':'',
'fcdfcaf004':'',
'fcdfcaf005':'',
'fcdfcaf006':'',
'fcdfcaf007':'',
'fcdfcaf008':'',
'fcdfcaf009':'',
'fcdfcaf010':'',
'fcdfcaf011':'',
'fcdfcaf012':'',
'fcdfcaf013':'',
'fcdfcaf014':'',
'fcdfcaf015':'',
'fcdfcaf016':'',
'fcdfcaf017':'',
'fcdfcaf018':'',
'fcdfcaf019':'',
'fcdfcaf020':'',
'fcdfcaf021':'',
'fcdfcaf022':'',
'fcdfcaf023':'',
'fcdfcaf024':'',
'fcdfcaf025':'',
'fcdfcaf026':'',
'fcdfcaf027':'',
'fcdfcaf028':'',
'fcdfcaf029':'',
'fcdfcaf030':'',
'fcdfcaf031':'',
'fcdfcaf032':'',
'fcdfcaf033':'',
'fcdfcaf034':'',
'fcdfcaf035':'',
'fcdfcaf036':'',
'fcdfcaf037':'',
'fcdfcaf038':'',
'fcdfcaf039':'',
'fcdfcaf040':'',
'fcdfcaf041':'',
'fcdfcaf042':'',
'fcdfcaf043':'',
'fcdfcaf044':'',
'fcdfcaf045':'',
'fcdfcaf046':'',
'fcdfcaf047':'',
'fcdfcaf048':'',
'fcdfcaf049':'',
'fcdfcaf050':'',
'fcdfcaf051':'',
'fcdfcaf052':'',
'fcdfcaf053':'',
'fcdfcaf054':'',
'fcdfcaf055':'',
'fcdfcaf056':'',
'fcdfcaf057':'',
'fcdfcaf058':'',
'fcdfcaf059':'',
'fcdfcaf060':'',
'fcdfcaf061':'',
'fcdfcaf062':'',
'fcdfcaf063':'',
'fcdfcaf064':'',
'fcdfcaf065':'',
'fcdfcaf066':'',
'fcdfcaf067':'',
'fcdfcaf068':'Stage 2 test',
'fcdfcaf069':'',
'fcdfcaf070':'',
'fcdfcaf071':'',
'fcdfcaf072':'',
'fcdfcaf073':'',
'fcdfcaf074':'',
'fcdfcaf075':'',
'fcdfcaf076':'',
'fcdfcaf077':'',
'fcdfcaf078':'',
'fcdfcaf079':'',
'fcdfcaf080':'',
'fcdfcaf081':'',
'fcdfcaf082':'',
'fcdfcaf083':'',
'fcdfcaf084':'',
'fcdfcaf085':'',
'fcdfcaf086':'',
'fcdfcaf087':'',
'fcdfcaf088':'',
'fcdfcaf089':'',
'fcdfcaf090':'',
'fcdfcaf091':'',
'fcdfcaf092':'',
'fcdfcaf093':'',
'fcdfcaf094':'',
'fcdfcaf095':'',
'fcdfcaf096':'',
'fcdfcaf097':'',
'fcdfcaf098':'',
'fcdfcaf099':'',
'fcdfcaf100':'',
'fcdfcaf101':'',
'fcdfcaf102':'',
'fcdfcaf103':'',
'fcdfcaf104':'',
'fcdfcaf105':'',
'fcdfcaf106':'',
'fcdfcaf107':'',
'fcdfcaf108':'',
'fcdfcaf109':'',
'fcdfcaf110':'',
'fcdfcaf111':'',
'fcdfcaf112':'',
'fcdfcaf113':'',
'fcdfcaf114':'',
'fcdfcaf115':'',
'fcdfcaf116':'',
'fcdfcaf117':'',
'fcdfcaf118':'',
'fcdfcaf119':'',
'fcdfcaf120':'',
'fcdfcaf121':'',
'fcdfcaf122':'',
'fcdfcaf123':'',
'fcdfcaf124':'',
'fcdfcaf125':'',
'fcdfcaf126':'',
'fcdfcaf127':'',
'fcdfcaf128':'',
'fcdfcaf129':'',
'fcdfcaf130':'',
'fcdfcaf131':'',
'fcdfcaf132':'',
'fcdfcaf133':'',
'fcdfcaf134':'',
'fcdfcaf135':'',
'fcdfcaf136':'',
'fcdfcaf137':'',
'fcdfcaf138':'',
'fcdfcaf139':'',
'fcdfcaf140':'',
'fcdfcaf141':'',
'fcdfcaf142':'',
'fcdfcaf143':'',
'fcdfcaf144':'',
'fcdfcaf145':'',
'fcdfcaf146':'',
'fcdfcaf147':'',
'fcdfcaf148':'',
'fcdfcaf149':'',
'fcdfcaf150':'',
'fcdfcaf151':'',
'fcdfcaf152':'',
'fcdfcaf153':'',
'fcdfcaf154':'',
'fcdfcaf155':'',
'fcdfcaf156':'',
'fcdfcaf157':'',
'fcdfcaf158':'',
'fcdfcaf159':'',
'fcdfcaf160':'',
'fcdfcaf161':'',
'fcdfcaf162':'',
'fcdfcaf163':'',
'fcdfcaf164':'',
'fcdfcaf165':'',
'fcdfcaf166':'',
'fcdfcaf167':'',
'fcdfcaf168':'',
'fcdfcaf169':'',
'fcdfcaf170':'',
'fcdfcaf171':'',
'fcdfcaf172':'',
'fcdfcaf173':'',
'fcdfcaf174':'',
'fcdfcaf175':'',
'fcdfcaf176':'',
'fcdfcaf177':'',
'fcdfcaf178':'',
'fcdfcaf179':'',
'fcdfcaf180':'',
'fcdfcaf181':'',
'fcdfcaf182':'',
'fcdfcaf183':'',
'fcdfcaf184':'',
'fcdfcaf185':'',
'fcdfcaf186':'',
'fcdfcaf187':'',
'fcdfcaf188':'',
'fcdfcaf189':'',
'fcdfcaf190':'',
'fcdfcaf191':'',
'fcdfcaf192':'',
'fcdfcaf193':'',
'fcdfcaf194':'',
'fcdfcaf195':'',
'fcdfcaf196':'',
'fcdfcaf197':'',
'fcdfcaf198':'',
'fcdfcaf199':'',
'fcdfcaf200':'',
'fcdfcaf201':'',
'fcdfcaf202':'',
'fcdfcaf203':'',
'fcdfcaf204':'',
'fcdfcaf205':'',
'fcdfcaf206':'',
'fcdfcaf207':'',
'fcdfcaf208':'',
'fcdfcaf209':'',
'fcdfcaf210':'',
'fcdfcaf211':'',
'fcdfcaf212':'',
'fcdfcaf213':'',
'fcdfcaf214':'',
'fcdfcaf215':'',
'fcdfcaf216':'',
'fcdfcaf217':'',
'fcdfcaf218':'',
'fcdfcaf219':'',
'fcdfcaf220':'',
'fcdfcaf221':'',
'fcdfcaf222':'',
'fcdfcaf223':'',
'fcdfcaf224':'',
'fcdfcaf225':'',
'fcdfcaf226':'',
'fcdfcaf227':'',
'fcdfcaf228':'',
'fcdfcaf229':'',
'fcdfcaf230':'',
'fcdfcaf231':'',
'fcdfcaf232':'',
'fcdfcaf233':'',
'fcdfcaf234':'',
'fcdfcaf235':'',
'fcdfcaf236':'',
'fcdfcaf237':'',
'fcdfcaf238':'',
'fcdfcaf239':'',
'fcdfcaf240':'',
'fcdfcaf241':'',
'fcdfcaf242':'',
'fcdfcaf243':'',
'fcdfcaf244':'',
'fcdfcaf245':'',
'fcdfcaf246':'',
'fcdfcaf247':'',
'fcdfcaf248':'',
'fcdfcaf249':'',
'fcdfcaf250':'',
'fcdfcaf251':'',
'fcdfcaf252':'',
'fcdfcaf253':'',
'fcdfcaf254':'',
'fcdfcaf255':'',
'fcdfcaf256':'',
'fcdfcaf257':'',
'fcdfcaf258':'',
'fcdfcaf259':'',
'fcdfcaf260':'',
'fcdfcaf261':'',
'fcdfcaf262':'',
'fcdfcaf263':'',
'fcdfcaf264':'',
'fcdfcaf265':'',
'fcdfcaf266':'',
'fcdfcaf267':'',
'fcdfcaf268':'',
'fcdfcaf269':'',
'fcdfcaf270':'',
'fcdfcaf271':'',
'fcdfcaf272':'',
'fcdfcaf273':'',
'fcdfcaf274':'',
'fcdfcaf275':'',
'fcdfcaf276':'',
'fcdfcaf277':'',
'fcdfcaf278':'',
'fcdfcaf279':'',
'fcdfcaf280':'',
'fcdfcaf281':'',
'fcdfcaf282':'',
'fcdfcaf283':'',
'fcdfcaf284':'',
'fcdfcaf285':'',
'fcdfcaf286':'',
'fcdfcaf287':'',
'fcdfcaf288':'',
'fcdfcaf289':'',
'fcdfcaf290':'',
'fcdfcaf291':'',
'fcdfcaf292':'',
'fcdfcaf293':'',
'fcdfcaf294':'',
'fcdfcaf295':'',
'fcdfcaf296':'',
'fcdfcaf297':'',
'fcdfcaf298':'',
'fcdfcaf299':'',
'fcdfcaf300':'',
'fcdfcaf301':'',
'fcdfcaf302':'',
'fcdfcaf303':'',
'fcdfcaf304':'',
'fcdfcaf305':''

}

ncols = 4

Style = """
<STYLE TYPE="text/css">
  h2 { margin-left: +0%; color: #000000}
  h3 { margin-left: +0%; color: #228800}
  p { color: #000000 }
  blockquote { margin-left: +2%; color: #FF33333 }
  pre { color: #990033 }
</STYLE>
"""

def htmlHead(title='CDF CAF Admin Monitoring page', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print '<p><table border=0>'
    print '  <tr valign="center">'
    print '  <td width="100"  valign="center" halign="center">'
    print '    <a href="http://cdfcaf.fnal.gov/">'
    print '    <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '  <td valign="center" halign="center"><h1><font size=+10>'
    print '    CDF Central Analysis Facility<br></font></h1>'
    print '    <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '  </tr>'
    print '</table>'
    print    
    print '<hr>'
    print    

def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

def htmlBody():
    print '<body bgcolor="white">'
    print '<form method="get" action="/cgi-bin/caf/admin/graphs.py">'
    print    

    # Statistics
    print '<h2>Check the statistics to view</h2>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="stat" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    for i in range(len(stats)):
        statsList = stats[i+1]
        print '<td width="25%" valign="top"><font color="#990033">'
        print '  <input type="checkbox" name="stat%s" value="%s"> %s</a>' %\
              (i, statsList[0], statsList[1])
        
    print '<br>'
    print '</font></td>'
    print '</tr>'
    print '</table><p>'
    print '<hr>'
    print    
    print '<h2>Check the nodes to view above statistics on:</h2>'
    print    

    # Utility nodes
    print '<h3>Utility nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodeutil" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(utility_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(utility_nodes) / ncols) + 1
    for i in range(len(utility_nodes)):
        un = utility_nodes[i+1]
        print '  <input type="checkbox" name="nodeutil%s" value="%s"> %s</a><br>' \
              % (i, un, un)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Servers
    print '<h3>Servers</h3>'
    print '<table border=0 width=515><tr>'

    # all, static and dCache buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodesrv" value="all">ALL </a>'
    print '  <input type="checkbox" name="nodesrv" value="dCache">dCache </a>'
    print '  <input type="checkbox" name="nodesrv" value="static1">Stage 1 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="static2">Stage 2 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="teststand">dCache test stand </a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="50%" valign="top"><font color="#990033">'
    ncols = 1
    irow = 0
    if len(servers) == ncols:
        nrows = 1
    else:
        nrows = int(len(servers) / ncols) + 1
    for i in range(len(servers)):
        srv = servers[i+1]
        if (node_description.has_key(srv) and len(node_description[srv]) > 0) : 
            description = ' - '+node_description[srv]
        else:
            description = ''
        print '  <input type="checkbox" name="nodesrv%s" value="%s"> %s %s</a><br>' \
              % (i, srv, srv, description)
        irow = irow+1
        if irow == 16:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0
            
    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Worker nodes
    print '<h3>Worker nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all, Stage 1, and Stage 2 buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="node" value="all">ALL </a>'
    print '  <input type="checkbox" name="node" value="Stage1">Stage 1 </a>'
    print '  <input type="checkbox" name="node" value="Stage2">Stage 2 - all </a>'
    print '  <input type="checkbox" name="node" value="Stage2-static">Stage 2 - static</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 1
    if len(worker_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(worker_nodes) / ncols) + 1
#    nrows = int(len(worker_nodes) / ncols)
    irow = 0
    for i in range(len(worker_nodes)):
        wn = worker_nodes[i+1]
        if (node_description.has_key(wn) and len(node_description[wn]) > 0) : 
            description = ' - '+node_description[wn]
        else:
            description = ''
        print '  <input type="checkbox" name="node%s" value="%s"> %s %s</a><br>' \
              % (i, wn, wn, description)
        irow = irow+1
        if irow == 67:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print '<hr>'
    print    
    print '<br>'
    print '<input type="checkbox" name="optlog" value="1"> Log plots?</a>'
    print '</br>'
    print '<hr>'
    print    
    print '<input type="submit" value="Submit">'

#    from time import localtime, time
#    (yr, mon, day, hr, min, sec, wkday, jday, dsf) = localtime(time())
#    print '<b>Start Date:</b>'
#    print '<input name="start_mon" size="2" value="'+str(mon)+'">'
#    print '<input name="start_day" size="2" value="'+str(day)+'">'
#    print '<input name="start_yr" size="4" value='+str(yr)+'">'
#    print '<b>Start Time:</b>'
#    print '<input name="start_hr" size="2" value="'+str(hr)+'">'
#    print '<input name="start_min" size="2" value="'+str(min)+'">'
#    print '<br>'
#    print 'Month(MM) Year(20YY)'

    print '</form>'

if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()


