#!/usr/bin/python
import cgi
import sys
import commands

RRD_ROOT_DIR = "/home/cafmon/batchmon/RRD"
RRDTOOL_BIN  = "/home/cafmon/bin/rrdtool"

graphDictUser = {
    "pending":"--title=\"Number of Pending Processes\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Npending:AVERAGE LINE2:val1#BB0000:Npending",
    "running":"--title=\"Number of Running Processes\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Nrunning:AVERAGE LINE2:val1#BB0000:Nrunning",
    "wait_time":"--title=\"Wait Time for Job to Start\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Twait:AVERAGE LINE2:val1#BB0000:Twait",
    "start_time_diff":"--title=\"Time Difference Between Processes Starting\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Tstart:AVERAGE LINE2:val1#BB0000:Twait",
    "exec_time":"--title=\"Process Execution Time\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Texec:AVERAGE LINE2:val1#BB0000:Texec"
    }

dataTypes = ["pending", "running", "wait_time", "start_time_diff",
             "exec_time"]

def main():

    print 'Content-type: text/html\n\n'
    print '<HTML>'
    print '<HEAD>'
    print '<TITLE>CAF User Monitor</TITLE>'
    print '<META http-equiv="refresh" content="300">'
    print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    print '</HEAD>'

    print '<BODY BGCOLOR="#80DDCB" LINK="#000000" VLINK="#000000" ALINK="#000000">'
 
    print '<CENTER>'
    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="top" WIDTH="10%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=1day">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">day</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=3days">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">3 days</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=1week">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=2weeks">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">2 weeks</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=1month">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="18%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=3months">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">3 months</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/genGraphUser.py?opt=gstat&inter=1year">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'

    period = "1day"
 
    optDict = cgi.FieldStorage()
    for opt in optDict.keys():
        if opt == "user":
            userName = optDict[opt].value
        elif opt == "period":
            period = optDict[opt].value

    graphGlobal = ""
    startStr = " --start -%s " % period

    for dataType in dataTypes:

        graphFile = "/var/www/cgi-bin/caf/userMon/graphs/user_%s_%s_%s.gif" % \
                    (userName, dataType, period)

        graphStr = graphGlobal + startStr + \
                    (graphDictUser[dataType] % (RRD_ROOT_DIR, userName))

        command = "%s graph %s %s" % (RRDTOOL_BIN, graphFile, graphStr)

        commands.getoutput(command)
        print '<img src="http://cdfmon.cr.cnaf.infn.it:8081/cgi-bin/caf/userMon/getgraph.py?graph=user_%s_%s_%s.gif"></tr></td>' % (userName, dataType, period)

    print '</BODY></HTML>'


if __name__ == "__main__":
    main()

