#!/usr/bin/python
########################################################################################

import cgi
import os
import commands
import time
import string
import sys
#sys.path.insert(1,"/local/ups/prd/fbsng/v1_3f+p2_1/Linux/lib")
#sys.path.insert(1,"/local/ups/prd/fcslib/v2_1/NULL/lib")
sys.path.insert(1,"/local/ups/prd/fbsng/v1_4/Linux/lib")
sys.path.insert(1,"/local/ups/prd/fcslib/v2_1/NULL/lib")


from FBS_API import *

#
# Global Variables:
#

#GlobalDir = '/caf/users/global'
GlobalDir = "/home/cafmon/fbsmon/graphs_and_images/global"



def GlobalStatus(period):

    #
    # --- Global Graph:
    #
    
    print '<CENTER>'
    print '   <H2><FONT COLOR="#111133">CAF Global Status</FONT></H2>'
    print '   <FONT COLOR="#111133" size=-1>(click on the graph to see the status vs the <b>number</b> of available CPUs)</font>'

    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstat&inter=day">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last 24h</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstat&inter=week">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstat&inter=month">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstat&inter=year">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'
    print '   <A HREF="/cgi-bin/caf/users/Body.py?opt=gstatCPU&inter=day" target="mbody">' 
    print '   <IMG SRC="/caf/users/global/graph_total_%s.gif"BORDER="0" ALT="CAF global status as a percentage of available CPUs"></a><BR>' % period[0]
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'

    #
    # --- Summary Table:
    #
    PrintSummaryTable()


def GlobalStatus_CPU(period):

    #
    # --- Global Graph:
    #
    
    print '<CENTER>'
    print '   <H2><FONT COLOR="#111133">CAF Global Status</FONT></H2>'
    print '   <FONT COLOR="#111133" size="-1">(click on the graph to see the status vs the <b>percentage</b> of available CPUs)</font>'

    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstatCPU&inter=day">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last 24h</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstatCPU&inter=week">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstatCPU&inter=month">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="25%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/users/Body.py?opt=gstatCPU&inter=year">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">last year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'
    print '   <A HREF="/cgi-bin/caf/users/Body.py?opt=gstat&inter=%s" target=mbody>' % period[0] 
    print '   <IMG SRC="/caf/users/global/graph_total_CPU_%s.gif" BORDER="0" ALT="CAF global status vs the number of available CPUs"></a><BR>' % period[0]
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'

    #
    # --- Summary Table:
    #
    PrintSummaryTable()


def PrintSummaryTable():
    f = open("%s/SummaryTable.dat" % GlobalDir, "r")
    data = string.split(f.readline(),"\t")
    f.close()

    for i in range(12,29):
        if data[i] == "-999.00":
            data[i] = "0.0"

    print '<P>'
    print '<CENTER>'
    print '<H2><FONT COLOR="#111133">Summary Table</FONT></H2>'
    print '<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="40%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">&nbsp;</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Short </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Medium</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Long  </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Groups</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Other </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" NOWRAP><FONT COLOR="#80DBCB" SIZE="-1">All Types</FONT></TH>'
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;Running processes</TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[0]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[1]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[2]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[3]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[4]          
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[5]
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC">&nbsp;&nbsp;&nbsp;Pending processes</TD>'
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[6]
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[7]
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[8]
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[9]
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[10]
    print '   <TD VALIGN="center" HEIGHT=35  BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[11]                
    print '</TR>'

    print '   <tr>'
    print '         <TD VALIGN="bottom" HEIGHT=25 BGCOLOR="#AAAAAA" colspan=7 NOWRAP>&nbsp;&nbsp;&nbsp;Waiting time [hh:mm] &nbsp; (24h average):</TD>'
    print '   </tr><tr>'
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;per &nbsp; job</TD>'
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[12]
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[13]
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[14]
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[15] 
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[16]
    print '         <TD VALIGN="center" HEIGHT=12  BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[17]
    print '   </TR>'

    print '      <TR>'
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;per &nbsp; section</TD>'
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[18]
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[19]
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[20]
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[21]
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[22]
    print '         <TD VALIGN="top" HEIGHT=20 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER>%s</CENTER></FONT></TD>' % data[23]            
    print '      </TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC" NOWRAP>&nbsp;&nbsp;&nbsp;Running time [hh:mm] &nbsp; (24h average)</TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[24]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[25]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[26]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[27]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[28]
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT COLOR="#000000" SIZE="+0"> <CENTER>%s</CENTER></FONT></TD>' % data[29]
    print '</TR>'
    print '<TR>'
    print '   <TD COLSPAN="7" ALIGN="right" VALIGN="top" BGCOLOR="#80DDCB"><FONT COLOR="#000000" SIZE="-1">Updated: %s</FONT></TD>' % data[30]
    print '</TR>'    

    print '</TABLE>'
    print '</CENTER>'
                 


def ActiveQueues():

    #
    # --- Active queues graph:
    #
    
    print '<CENTER><FONT COLOR="#111133"><H2>Active queues in the last 24 hours</H2></FONT></CENTER>'
    print '<CENTER>'
    print '   <IMG SRC="/caf/users/global/active_queues.gif" BORDER="0"><BR>'
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT>' + \
              '<A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank">' + \
              '<FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'

    #preparing per1 and per2 data (3 days)
    per1 = time.strftime('%m/%d/%y', time.localtime(time.time()-259200))
    per2 = time.strftime('%m/%d/%y', time.localtime(time.time()))

    #
    # --- Active queues list:
    #

    f = open("%s/ActiveQueueList.dat" % GlobalDir, "r")
    Nq = string.atoi(f.readline()[:-1])
    queue = []
    while 1:
        line = f.readline()[:-1]
        if line:
            qn = string.split(line," ")
            queue.append(qn[0])
        else:
            break
    f.close()
    queue.sort()

    Ncol = 4
    Nrow = Nq / Ncol + 1

    ql = '<form method="get" action="/cgi-bin/caf/users/onfly_graphs.py">\n' + \
         '<center> \n' + \
         '<table border=0 width=550><tr>' + \
         '<th  valign="center" bgcolor="#111133" colspan=5 nosave>' + \
         '<font size=+1 color="#80DDCB">check the queues you want to plot ...</font></td> </tr><tr> \n'

    if Nq == 0:
        ql = ql + ' <td  align="center" valign="middle"><H2><FONT COLOR="#111133"> ' + \
             'no active queues </FONT></H2></td>'
    else:
        k = 0
        for i in range(Ncol):
            ql = ql + '<td width="25%" valign="top"><font size=+1>'

            j = 0
            while j < Nrow and k < Nq:
                #ql = ql + '<input type="checkbox" name="%s" value="%s"><A HREF="/cgi-bin/caf/users/User.py?opt=%s">%s</a></a>' %  (queue[k],queue[k],queue[k],queue[k]) + '<br>'
                ql = ql + '<input type="checkbox" name="%s" value="%s"><A HREF="/cgi-bin/caf/users/User3.py?opt=%s&per1=%s&per2=%s" target="new">%s</a></a>' %  (queue[k],queue[k],queue[k],per1,per2,queue[k]) + '<br>'
                j = j + 1
                k = k + 1
                #ql = ql + '<input type="checkbox" name="%s" value="%s"><A HREF="/cgi-bin/caf/users/Body.py?opt=user&inter=%s"> %s </a></a>' % \#                ql = ql + '<input type="checkbox" name="%s" value="%s"> %s</a>' % \
#                     (queue[k],queue[k],queue[k]) + '<br>'
    
            ql = ql + '</font></td>'

    ql = ql + '</tr><tr>\n' + \
         '<th vsize=40 valign="center" bgcolor="#111133" colspan=5 nosave><font size=+1 color="#80ddcb">\n' +\
         '... then click one of the buttons below </font></td> </tr>' + \
         '</table><p>\n' + \
         '<input type="submit" STYLE="background-color:#80DDCB" name="opt" value="CPU usage">\n' +\
         '<input type="submit" STYLE="background-color:#80DDCB" name="opt" value="W&R times">\n' +\
         '</center> \n' + \
         '</form>'

    print ql

    

def AllQueues():

    print '<CENTER><FONT COLOR="#111133"><H2>All CAF queues</H2></FONT></CENTER>'

    #preparing per1 and per2 data (3 days)
    per1 = time.strftime('%m/%d/%y', time.localtime(time.time()-259200))
    per2 = time.strftime('%m/%d/%y', time.localtime(time.time()))

    f = open("%s/QueueList.dat" % GlobalDir, "r")
    queue = string.split(f.readline()," ")
    f.close()

    Nq = string.atoi(queue[0])

    Ncol = 5
    Nrow = Nq / Ncol + 1

    ql = '<form method="get" action="/cgi-bin/caf/users/onfly_graphs.py">\n' + \
         '<center> \n' + \
         '<table border=0 width=650><tr>' + \
         '<th  valign="center" bgcolor="#111133" colspan=5 nosave>' + \
         '<font size=+1 color="#80DDCB">check the queues you want to plot ...</font></td> </tr><tr> \n'

    k = 0
    for i in range(Ncol):
        ql = ql + '<td width="20%" valign="top"><font size=+1>'

        j = 0
        while j < Nrow and k < Nq:
            ql = ql + '<input type="checkbox" name="%s" value="%s"><A HREF="/cgi-bin/caf/users/User3.py?opt=%s&per1=%s&per2=%s" target="new"> %s </a>' % \
                 (queue[k+2],queue[k+2],queue[k+2],per1,per2,queue[k+2]) + '<br>'
            j = j + 1
            k = k + 1
    
        ql = ql + '</font></td>'

    ql = ql + '</tr><tr>\n' + \
         '<th vsize=40 valign="center" bgcolor="#111133" colspan=5 nosave><font size=+1 color="#80ddcb">\n' +\
         '... then click one of the buttons below </font></td> </tr>' + \
         '</table><p>\n' + \
         '<input type="submit" STYLE="background-color:#80DDCB" name="opt" value="CPU usage">\n' +\
         '<input type="submit" STYLE="background-color:#80DDCB" name="opt" value="W&R times">\n' +\
         '</center> \n' + \
         '</form>'

    print ql



def CustomGraph(date1,date2):

    if time.mktime(time.strptime("%s" % date1,"%m/%d/%y")) < 1020232800.0:
        print '<BR><CENTER><H2><FONT COLOR="#000099">No data available before 05/01/02.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) > time.time():
        print '<BR><CENTER><H2><FONT COLOR="#000099">Sorry, we do not foresee the Future.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) < time.mktime(time.strptime("%s" % date1,"%m/%d/%y")):
        print '<BR><CENTER><H2><FONT COLOR="#000099">ERROR: Starting date is earlier than Ending date!' + \
              '</FONT></H2></CENTER>'
        return
    elif date1 == date2:
        print '<BR><CENTER><H2><FONT COLOR="#000099">Starting and Ending dates coincide.</FONT></H2></CENTER>'
        return
        

    GraphDir = "/caf/users/graphs"
    RRDdir = "/export/home/cafmon/bin"
    DBdir = "/caf/users/db/queues"

    Nnodes = getAvailableNodes()

    pid =  os.getpid()
    FileName = 'graph_total_%s.gif' % pid
    RRDfile = DBdir + '/total.rrd'


    Norm  = 50. / Nnodes
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )


    CMDstr = '%s/rrdtool graph %s/%s --start %s  --end %s' % (RRDdir,GraphDir,FileName,date1,date2) + \
             ' -v "Used CPUs [%]"  --units-exponent 0 -l 0 -u 100 -r' + \
             ' -w 455 -h 180 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB' + \
             ' DEF:totR=%s:NrT:AVERAGE CDEF:totRn=totR,%s,\* CDEF:totRn1=totRn,100,GT,100,totRn,IF' % (RRDfile,Norm) + \
             ' DEF:rS=%s:NrS:AVERAGE CDEF:rSn=rS,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rSn1=rSn,0.1,LT,0,rSn,IF' + \
             ' DEF:rM=%s:NrM:AVERAGE CDEF:rMn=rM,%s,\*' % (RRDfile,Norm) + \
             ' DEF:rL=%s:NrL:AVERAGE CDEF:rLn=rL,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rLn1=rLn,0.1,LT,0,rLn,IF' + \
             ' DEF:rGSI=%s/italy.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMI=%s/mit.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGPI=%s/pitt.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGCM=%s/cmu.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMC=%s/cdfmc.rrd:NrT:AVERAGE' % DBdir  + \
             ' DEF:rGOP=%s/cdfopr.rrd:NrT:AVERAGE' % DBdir + \
             ' CDEF:rgT=rGSI,rGMI,rGPI,rGCM,+,+,+ CDEF:rgT1=rgT,%s,\*' % Norm + \
             ' CDEF:roT=rGMC,rGOP,+ CDEF:roT1=roT,%s,\*' % Norm + \
             ' COMMENT:"----------------------------\\n"' + \
             ' COMMENT:"    ptype        Average % \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rSn\#FFFF00:" Short        "' + \
             ' GPRINT:rSn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' LINE2:rMn\#BB0000:" Medium       "' + \
             ' GPRINT:rMn:AVERAGE:"%8.1lf %s \\n"' +  \
             ' LINE2:rLn\#3333FF:" Long         "' + \
             ' GPRINT:rLn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rgT1\#00FF00:" Groups       "' + \
             ' GPRINT:rgT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' LINE2:roT1\#FF00FF:" Others       "' + \
             ' GPRINT:roT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE1:totRn1\#FFFFFF:" All processes"' + \
             ' GPRINT:totRn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"                                                         Created on %s"' % Date
    
    commands.getoutput(CMDstr)


    print '<CENTER>'
    print '   <H2><FONT COLOR="#111133">CAF Global Status from </FONT><FONT COLOR="#CC0000">' + \
          '%s </FONT><FONT COLOR="#111133">to</FONT> <FONT COLOR="#CC0000">%s</FONT></H2>' % (date1,date2)
    print '   <IMG SRC="/caf/users/graphs/%s"BORDER="0"><BR>' % FileName
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'

def getAvailableNodes():
    FBSNGcfg = "/home/cdfcaf/CafSetup/fbsng/cfg/fbs.cfg"
    fc = FBSClient('FBSmon',FBSNGcfg)
    nodelist = fc.getNodeList()
    ntot = 0
    for node in nodelist:
        n = fc.getNode(node)
        #print n.Name, n.IsUp, n.Class, n.Resources, n.Processes
        if n.IsUp and n.Class == "worker":
            ntot = ntot+1
    return ntot

def main():
    
    opt = cgi.FieldStorage()

    print 'Content-type: text/html\n\n'
    print '<HTML>'
    print '<HEAD>'
    print '<TITLE>CAF User Monitor</TITLE>'
    print '<META http-equiv="refresh" content="300">'
    print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    print '</HEAD>'
    
    print '<BODY BGCOLOR="#80DDCB" LINK="#000000" VLINK="#000000" ALINK="#000000">'

    if opt["opt"].value == "gstat":
        GlobalStatus(opt["inter"].value)

    elif opt["opt"].value == "gstatCPU":
        GlobalStatus_CPU(opt["inter"].value)

    elif opt["opt"].value == "actque":
        ActiveQueues()

    elif opt["opt"].value == "allque":
        AllQueues()        

    #elif opt["opt"].value == "user":
    #    User(opt["inter"].value)

    else:
        if opt["opt"].value == 'MM/DD/YY':
            print '<BR><CENTER><H2><FONT COLOR="#000099">Please, enter the starting date.</FONT></H2></CENTER>'
            return
        CustomGraph(opt["opt"].value,opt["inter"].value)


    print '</BODY></HTML>'

if __name__ == "__main__":
    main()
