#!/usr/bin/python
import cgi
import commands
import os
import string

stats = {
    1:['load_average', 'Load averages'],
    2:['cpu','CPU usage'],
    3:['netxfer','Network throughput'],
    4:['memory','Memory usage']
    }

utility_nodes = [
    'fcdfhead1', 'fcdfhead2', 'fcdfmon1', 'fcdfcode1', 'fcdflnx1', 'fcdflnx2',
    'fcdflnx3'
    ]

servers = [
    'fcdfdata001', 'fcdfdata002', 'fcdfdata003', 'fcdfdata004', 'fcdfdata005',
    'fcdfdata006', 'fcdfdata007', 'fcdfdata008', 'fcdfdata009', 'fcdfdata010',
    'fcdfdata011', 'fcdfdata012', 'fcdfdata013', 'fcdfdata014', 'fcdfdata015',
    'fcdfdata016', 'fcdfdata017', 'fcdfdata018', 'fcdfdata019', 'fcdfdata020',
    'fcdfdata021', 'fcdfdata022', 'fcdfdata023', 'fcdfdata024', 'fcdfdata025',
    'fcdfdata026', 'fcdfdata027', 'fcdfdata028', 'fcdfdata029', 'fcdfdata030',
    'fcdfdata031', 'fcdfdata032', 'fcdfdata033', 'fcdfdata034', 'fcdfdata035',
    'fcdfdata036', 'fcdfdata037', 'fcdfdata038', 'fcdfdata039', 'fcdfdata040',
    'fcdfdata041', 'fcdfdata042', 'fcdfdata043', 'fcdfdata044', 'fcdfdata045',
    'fcdfdata046', 'fcdfdata047', 'fcdfdata048', 'fcdfdata049', 'fcdfdata050',
    'fcdfdata051', 'fcdfdata052', 'fcdfdata053', 'fcdfdata054', 'fcdfdata055',
    'fcdfdata056', 'fcdfdata057', 'fcdfdata058', 'fcdfdata059', 'fcdfdata060',
    'fcdfdata061', 'fcdfdata062', 'fcdfdata063', 'fcdfdata064', 'fcdfdata065',
    'fcdfdata066', 'fcdfdata067', 'fcdfdata068', 'fcdfdata069', 'fcdfdata070',
    'fcdfdata071', 'fcdfdata072', 'fcdfdata073', 'fcdfdata074', 'fcdfdata075',
    'fcdfdata076', 'fcdfdata077', 'fcdfdata078', 'fcdfdata079', 'fcdfdata080',
    'fcdfdata081', 'fcdfdata082', 'fcdfdata083', 'fcdfdata084', 'fcdfdata085',
    'fcdfdata086', 'fcdfdata087', 'fcdfdata088', 'fcdfdata089', 'fcdfdata090',
    'fcdfdata091', 'fcdfdata092'
    ]

worker_nodes = [
    'fcdfcaf001', 'fcdfcaf002', 'fcdfcaf003', 'fcdfcaf004', 'fcdfcaf005',
    'fcdfcaf006', 'fcdfcaf007', 'fcdfcaf008', 'fcdfcaf009', 'fcdfcaf010',
    'fcdfcaf011', 'fcdfcaf012', 'fcdfcaf013', 'fcdfcaf014', 'fcdfcaf015',
    'fcdfcaf016', 'fcdfcaf017', 'fcdfcaf018', 'fcdfcaf019', 'fcdfcaf020',
    'fcdfcaf021', 'fcdfcaf022', 'fcdfcaf023', 'fcdfcaf024', 'fcdfcaf025',
    'fcdfcaf026', 'fcdfcaf027', 'fcdfcaf028', 'fcdfcaf029', 'fcdfcaf030',
    'fcdfcaf031', 'fcdfcaf032', 'fcdfcaf033', 'fcdfcaf034', 'fcdfcaf035',
    'fcdfcaf036', 'fcdfcaf037', 'fcdfcaf038', 'fcdfcaf039', 'fcdfcaf040',
    'fcdfcaf041', 'fcdfcaf042', 'fcdfcaf043', 'fcdfcaf044', 'fcdfcaf045',
    'fcdfcaf046', 'fcdfcaf047', 'fcdfcaf048', 'fcdfcaf049', 'fcdfcaf050',
    'fcdfcaf051', 'fcdfcaf052', 'fcdfcaf057', 'fcdfcaf058', 'fcdfcaf059',
    'fcdfcaf060', 'fcdfcaf061', 'fcdfcaf062', 'fcdfcaf063', 'fcdfcaf064',
    'fcdfcaf065', 'fcdfcaf066', 'fcdfcaf067',
    
    'fcdfcaf068', 'fcdfcaf069', 'fcdfcaf070', 'fcdfcaf071', 'fcdfcaf072',
    'fcdfcaf073', 'fcdfcaf074', 'fcdfcaf075', 'fcdfcaf076', 'fcdfcaf077',
    'fcdfcaf078', 'fcdfcaf079', 'fcdfcaf080', 'fcdfcaf081', 'fcdfcaf082',
    'fcdfcaf083', 'fcdfcaf084', 'fcdfcaf085', 'fcdfcaf086', 'fcdfcaf087', 
    'fcdfcaf088', 'fcdfcaf089', 'fcdfcaf090', 'fcdfcaf091', 'fcdfcaf092',
    'fcdfcaf093', 'fcdfcaf094', 'fcdfcaf095', 'fcdfcaf096', 'fcdfcaf097',
    'fcdfcaf098', 'fcdfcaf099', 'fcdfcaf100', 'fcdfcaf101', 'fcdfcaf102',
    'fcdfcaf103', 'fcdfcaf104', 'fcdfcaf105', 'fcdfcaf106', 'fcdfcaf107', 
    'fcdfcaf108', 'fcdfcaf109', 'fcdfcaf110', 'fcdfcaf111', 'fcdfcaf112',
    'fcdfcaf113', 'fcdfcaf114', 'fcdfcaf115', 'fcdfcaf116', 'fcdfcaf117',
    'fcdfcaf118', 'fcdfcaf119', 'fcdfcaf120', 'fcdfcaf121', 'fcdfcaf122',
    'fcdfcaf123', 'fcdfcaf124', 'fcdfcaf125', 'fcdfcaf126', 'fcdfcaf127', 
    'fcdfcaf128', 'fcdfcaf129', 'fcdfcaf130', 'fcdfcaf131', 'fcdfcaf132',
    'fcdfcaf133', 'fcdfcaf134', 'fcdfcaf135', 'fcdfcaf136', 'fcdfcaf137',
    'fcdfcaf138', 'fcdfcaf139', 'fcdfcaf140', 'fcdfcaf141', 'fcdfcaf142',
    'fcdfcaf143', 'fcdfcaf144', 'fcdfcaf145', 'fcdfcaf146', 'fcdfcaf147', 
    'fcdfcaf148', 'fcdfcaf149', 'fcdfcaf150', 'fcdfcaf151', 'fcdfcaf152',
    'fcdfcaf153', 'fcdfcaf154', 'fcdfcaf155', 'fcdfcaf156', 'fcdfcaf157',
    'fcdfcaf158', 'fcdfcaf159', 'fcdfcaf160', 'fcdfcaf161', 'fcdfcaf162',
    'fcdfcaf163', 'fcdfcaf164', 'fcdfcaf165', 'fcdfcaf166', 'fcdfcaf167', 
    'fcdfcaf168', 'fcdfcaf169', 'fcdfcaf170', 'fcdfcaf171', 'fcdfcaf172',
    'fcdfcaf173', 'fcdfcaf174', 'fcdfcaf175', 'fcdfcaf176', 'fcdfcaf177',
    'fcdfcaf178', 'fcdfcaf179', 'fcdfcaf180', 'fcdfcaf181', 'fcdfcaf182',
    'fcdfcaf183', 'fcdfcaf184', 'fcdfcaf185', 'fcdfcaf186', 'fcdfcaf187', 
    'fcdfcaf188', 'fcdfcaf189', 'fcdfcaf190', 'fcdfcaf191', 'fcdfcaf192',
    'fcdfcaf193', 'fcdfcaf194', 'fcdfcaf195', 'fcdfcaf196', 'fcdfcaf197',
    'fcdfcaf198', 'fcdfcaf199', 'fcdfcaf200', 'fcdfcaf201', 'fcdfcaf202',
    'fcdfcaf203', 'fcdfcaf204', 'fcdfcaf205', 'fcdfcaf206', 'fcdfcaf207',
    'fcdfcaf208', 'fcdfcaf209', 'fcdfcaf210', 'fcdfcaf211', 'fcdfcaf212',
    'fcdfcaf213', 'fcdfcaf214', 'fcdfcaf215', 'fcdfcaf216', 'fcdfcaf217',
    'fcdfcaf218', 'fcdfcaf219', 'fcdfcaf220', 'fcdfcaf221', 'fcdfcaf222',
    'fcdfcaf223', 'fcdfcaf224', 'fcdfcaf225', 'fcdfcaf226', 'fcdfcaf227',
    'fcdfcaf228', 'fcdfcaf229', 'fcdfcaf230', 'fcdfcaf231', 'fcdfcaf232',
    'fcdfcaf233', 'fcdfcaf234', 'fcdfcaf235', 'fcdfcaf236', 'fcdfcaf237',
    'fcdfcaf238', 'fcdfcaf239', 'fcdfcaf240', 'fcdfcaf241', 'fcdfcaf242',
    'fcdfcaf243', 'fcdfcaf244', 'fcdfcaf245', 'fcdfcaf246', 'fcdfcaf247',
    'fcdfcaf248', 'fcdfcaf249', 'fcdfcaf250', 'fcdfcaf251', 'fcdfcaf252',
    'fcdfcaf253', 'fcdfcaf254', 'fcdfcaf255', 'fcdfcaf256', 'fcdfcaf257',
    'fcdfcaf258', 'fcdfcaf259', 'fcdfcaf260', 'fcdfcaf261', 'fcdfcaf262',
    'fcdfcaf263', 'fcdfcaf264', 'fcdfcaf265', 'fcdfcaf266', 'fcdfcaf267',
    'fcdfcaf268', 'fcdfcaf269', 'fcdfcaf270', 'fcdfcaf271', 'fcdfcaf272',
    'fcdfcaf273', 'fcdfcaf274', 'fcdfcaf275', 'fcdfcaf276', 'fcdfcaf277',
    'fcdfcaf278', 'fcdfcaf279', 'fcdfcaf280', 'fcdfcaf281', 'fcdfcaf282',
    'fcdfcaf283', 'fcdfcaf284', 'fcdfcaf285', 'fcdfcaf286', 'fcdfcaf287',
    'fcdfcaf288', 'fcdfcaf289', 'fcdfcaf290', 'fcdfcaf291', 'fcdfcaf292',
    'fcdfcaf293', 'fcdfcaf294', 'fcdfcaf295', 'fcdfcaf296', 'fcdfcaf297',
    'fcdfcaf298', 'fcdfcaf299', 'fcdfcaf300'
      ]

node_description = {

'fcdfdata001':'Static',
'fcdfdata002':'Static',
'fcdfdata003':'Static',
'fcdfdata004':'Static',
'fcdfdata005':'Static',
'fcdfdata006':'Static',
'fcdfdata007':'FTP: General icaf/scratch',
'fcdfdata008':'dCache pool',
'fcdfdata009':'dCache',
'fcdfdata010':'dCache',
'fcdfdata011':'dCache',
'fcdfdata012':'DB tests',
'fcdfdata013':'spare',
'fcdfdata014':'FTP: INFN',
'fcdfdata015':'Static',
'fcdfdata016':'SAM',
'fcdfdata017':'dCache',
'fcdfdata018':'dCache',
'fcdfdata019':'dCache',
'fcdfdata020':'dCache',
'fcdfdata021':'dCache',
'fcdfdata022':'dCache',
'fcdfdata023':'dCache',
'fcdfdata024':'dCache',
'fcdfdata025':'FTP: JHU',
'fcdfdata026':'FTP: INFN',
'fcdfdata027':'FTP: Florida',
'fcdfdata028':'FTP: UCDavis',
'fcdfdata029':'FTP: Harvard',
'fcdfdata030':'FTP: Duke',
'fcdfdata031':'FTP: Toronto',
'fcdfdata032':'FTP: UK',
'fcdfdata033':'on loan to Sloan DSS',
'fcdfdata034':'on loan to Sloan DSS',
'fcdfdata035':'dCache',
'fcdfdata036':'dCache',
'fcdfdata037':'dCache',
'fcdfdata038':'dCache',
'fcdfdata039':'dCache',
'fcdfdata040':'dCache',
'fcdfdata041':'FTP: Geneva',
'fcdfdata042':'FTP: Japan',
'fcdfdata043':'FTP: Cantabria',
'fcdfdata044':'FTP: INFN',
'fcdfdata045':'FTP: INFN',
'fcdfdata046':'FTP: Japan',
'fcdfdata047':'FTP: Penn',
'fcdfdata048':'FTP: Yale/Korea',
'fcdfdata049':'FTP: Purdue',
'fcdfdata050':'FTP: UIUC',
'fcdfdata051':'FTP: MIT',
'fcdfdata052':'dCache',
'fcdfdata053':'dCache',
'fcdfdata054':'dCache',
'fcdfdata055':'dCache',
'fcdfdata056':'dCache',
'fcdfdata057':'dCache',
'fcdfdata058':'dCache',
'fcdfdata059':'dCache',
'fcdfdata060':'dCache',
'fcdfdata061':'dCache',
'fcdfdata062':'dCache',
'fcdfdata063':'dCache',
'fcdfdata064':'dCache',
'fcdfdata065':'dCache',
'fcdfdata066':'dCache',
'fcdfdata067':'dCache',
'fcdfdata068':'dCache',
'fcdfdata069':'dCache',
'fcdfdata070':'dCache',
'fcdfdata071':'dCache',
'fcdfdata072':'dCache',
'fcdfdata073':'dCache',
'fcdfdata074':'dCache',
'fcdfdata075':'dCache',
'fcdfdata076':'Static',
'fcdfdata077':'Static',
'fcdfdata078':'Static',
'fcdfdata079':'Static',
'fcdfdata080':'Static',
'fcdfdata081':'Static',
'fcdfdata082':'Static',
'fcdfdata083':'Static',
'fcdfdata084':'Static',
'fcdfdata085':'Static',
'fcdfdata086':'Static',
'fcdfdata087':'Static',
'fcdfdata088':'Static',
'fcdfdata089':'FTP: Japan',
'fcdfdata090':'FTP: Japan',
'fcdfdata091':'FTP: Japan',
'fcdfdata092':'FTP: UK',

'fcdfcaf001':'Stage 1 test',
'fcdfcaf002':'',
'fcdfcaf003':'',
'fcdfcaf004':'',
'fcdfcaf005':'',
'fcdfcaf006':'',
'fcdfcaf007':'',
'fcdfcaf008':'',
'fcdfcaf009':'',
'fcdfcaf010':'',
'fcdfcaf011':'',
'fcdfcaf012':'',
'fcdfcaf013':'',
'fcdfcaf014':'',
'fcdfcaf015':'',
'fcdfcaf016':'',
'fcdfcaf017':'',
'fcdfcaf018':'',
'fcdfcaf019':'',
'fcdfcaf020':'',
'fcdfcaf021':'',
'fcdfcaf022':'',
'fcdfcaf023':'',
'fcdfcaf024':'',
'fcdfcaf025':'',
'fcdfcaf026':'',
'fcdfcaf027':'',
'fcdfcaf028':'',
'fcdfcaf029':'',
'fcdfcaf030':'',
'fcdfcaf031':'',
'fcdfcaf032':'',
'fcdfcaf033':'',
'fcdfcaf034':'',
'fcdfcaf035':'',
'fcdfcaf036':'',
'fcdfcaf037':'',
'fcdfcaf038':'',
'fcdfcaf039':'',
'fcdfcaf040':'',
'fcdfcaf041':'',
'fcdfcaf042':'',
'fcdfcaf043':'',
'fcdfcaf044':'',
'fcdfcaf045':'',
'fcdfcaf046':'',
'fcdfcaf047':'',
'fcdfcaf048':'',
'fcdfcaf049':'',
'fcdfcaf050':'',
'fcdfcaf051':'',
'fcdfcaf052':'',
'fcdfcaf057':'',
'fcdfcaf058':'',
'fcdfcaf059':'',
'fcdfcaf060':'',
'fcdfcaf061':'',
'fcdfcaf062':'',
'fcdfcaf063':'',
'fcdfcaf064':'',
'fcdfcaf065':'',
'fcdfcaf066':'',
'fcdfcaf067':'',
'fcdfcaf068':'Stage 2 test',
'fcdfcaf069':'',
'fcdfcaf070':'',
'fcdfcaf071':'',
'fcdfcaf072':'',
'fcdfcaf073':'',
'fcdfcaf074':'',
'fcdfcaf075':'',
'fcdfcaf076':'',
'fcdfcaf077':'',
'fcdfcaf078':'',
'fcdfcaf079':'',
'fcdfcaf080':'',
'fcdfcaf081':'',
'fcdfcaf082':'',
'fcdfcaf083':'',
'fcdfcaf084':'',
'fcdfcaf085':'',
'fcdfcaf086':'',
'fcdfcaf087':'',
'fcdfcaf088':'',
'fcdfcaf089':'',
'fcdfcaf090':'',
'fcdfcaf091':'',
'fcdfcaf092':'',
'fcdfcaf093':'',
'fcdfcaf094':'',
'fcdfcaf095':'',
'fcdfcaf096':'',
'fcdfcaf097':'',
'fcdfcaf098':'',
'fcdfcaf099':'',
'fcdfcaf100':'',
'fcdfcaf101':'',
'fcdfcaf102':'',
'fcdfcaf103':'',
'fcdfcaf104':'',
'fcdfcaf105':'',
'fcdfcaf106':'',
'fcdfcaf107':'',
'fcdfcaf108':'',
'fcdfcaf109':'',
'fcdfcaf110':'',
'fcdfcaf111':'',
'fcdfcaf112':'',
'fcdfcaf113':'',
'fcdfcaf114':'',
'fcdfcaf115':'',
'fcdfcaf116':'',
'fcdfcaf117':'',
'fcdfcaf118':'',
'fcdfcaf119':'',
'fcdfcaf120':'',
'fcdfcaf121':'',
'fcdfcaf122':'',
'fcdfcaf123':'',
'fcdfcaf124':'',
'fcdfcaf125':'',
'fcdfcaf126':'',
'fcdfcaf127':'',
'fcdfcaf128':'',
'fcdfcaf129':'',
'fcdfcaf130':'',
'fcdfcaf131':'',
'fcdfcaf132':'',
'fcdfcaf133':'',
'fcdfcaf134':'',
'fcdfcaf135':'',
'fcdfcaf136':'',
'fcdfcaf137':'',
'fcdfcaf138':'',
'fcdfcaf139':'',
'fcdfcaf140':'',
'fcdfcaf141':'',
'fcdfcaf142':'',
'fcdfcaf143':'',
'fcdfcaf144':'',
'fcdfcaf145':'',
'fcdfcaf146':'',
'fcdfcaf147':'',
'fcdfcaf148':'',
'fcdfcaf149':'',
'fcdfcaf150':'',
'fcdfcaf151':'',
'fcdfcaf152':'',
'fcdfcaf153':'',
'fcdfcaf154':'',
'fcdfcaf155':'',
'fcdfcaf156':'',
'fcdfcaf157':'',
'fcdfcaf158':'',
'fcdfcaf159':'',
'fcdfcaf160':'',
'fcdfcaf161':'',
'fcdfcaf162':'',
'fcdfcaf163':'',
'fcdfcaf164':'',
'fcdfcaf165':'',
'fcdfcaf166':'',
'fcdfcaf167':'',
'fcdfcaf168':'',
'fcdfcaf169':'',
'fcdfcaf170':'',
'fcdfcaf171':'',
'fcdfcaf172':'',
'fcdfcaf173':'',
'fcdfcaf174':'',
'fcdfcaf175':'',
'fcdfcaf176':'',
'fcdfcaf177':'',
'fcdfcaf178':'',
'fcdfcaf179':'',
'fcdfcaf180':'',
'fcdfcaf181':'',
'fcdfcaf182':'',
'fcdfcaf183':'',
'fcdfcaf184':'',
'fcdfcaf185':'',
'fcdfcaf186':'',
'fcdfcaf187':'',
'fcdfcaf188':'',
'fcdfcaf189':'',
'fcdfcaf190':'',
'fcdfcaf191':'',
'fcdfcaf192':'',
'fcdfcaf193':'',
'fcdfcaf194':'',
'fcdfcaf195':'',
'fcdfcaf196':'',
'fcdfcaf197':'',
'fcdfcaf198':'',
'fcdfcaf199':'',
'fcdfcaf200':'',
'fcdfcaf201':'',
'fcdfcaf202':'',
'fcdfcaf203':'',
'fcdfcaf204':'',
'fcdfcaf205':'',
'fcdfcaf206':'',
'fcdfcaf207':'',
'fcdfcaf208':'',
'fcdfcaf209':'',
'fcdfcaf210':'',
'fcdfcaf211':'',
'fcdfcaf212':'',
'fcdfcaf213':'',
'fcdfcaf214':'',
'fcdfcaf215':'',
'fcdfcaf216':'',
'fcdfcaf217':'',
'fcdfcaf218':'',
'fcdfcaf219':'',
'fcdfcaf220':'',
'fcdfcaf221':'',
'fcdfcaf222':'',
'fcdfcaf223':'',
'fcdfcaf224':'',
'fcdfcaf225':'',
'fcdfcaf226':'',
'fcdfcaf227':'',
'fcdfcaf228':'',
'fcdfcaf229':'',
'fcdfcaf230':'',
'fcdfcaf231':'',
'fcdfcaf232':'',
'fcdfcaf233':'',
'fcdfcaf234':'',
'fcdfcaf235':'',
'fcdfcaf236':'',
'fcdfcaf237':'',
'fcdfcaf238':'',
'fcdfcaf239':'',
'fcdfcaf240':'',
'fcdfcaf241':'',
'fcdfcaf242':'',
'fcdfcaf243':'',
'fcdfcaf244':'',
'fcdfcaf245':'',
'fcdfcaf246':'',
'fcdfcaf247':'',
'fcdfcaf248':'',
'fcdfcaf249':'',
'fcdfcaf250':'',
'fcdfcaf251':'',
'fcdfcaf252':'',
'fcdfcaf253':'',
'fcdfcaf254':'',
'fcdfcaf255':'',
'fcdfcaf256':'',
'fcdfcaf257':'',
'fcdfcaf258':'',
'fcdfcaf259':'',
'fcdfcaf260':'',
'fcdfcaf261':'',
'fcdfcaf262':'',
'fcdfcaf263':'',
'fcdfcaf264':'',
'fcdfcaf265':'',
'fcdfcaf266':'',
'fcdfcaf267':'',
'fcdfcaf268':'',
'fcdfcaf269':'',
'fcdfcaf270':'',
'fcdfcaf271':'',
'fcdfcaf272':'',
'fcdfcaf273':'',
'fcdfcaf274':'',
'fcdfcaf275':'',
'fcdfcaf276':'',
'fcdfcaf277':'',
'fcdfcaf278':'',
'fcdfcaf279':'',
'fcdfcaf280':'',
'fcdfcaf281':'',
'fcdfcaf282':'',
'fcdfcaf283':'',
'fcdfcaf284':'',
'fcdfcaf285':'',
'fcdfcaf286':'',
'fcdfcaf287':'',
'fcdfcaf288':'',
'fcdfcaf289':'',
'fcdfcaf290':'',
'fcdfcaf291':'',
'fcdfcaf292':'',
'fcdfcaf293':'',
'fcdfcaf294':'',
'fcdfcaf295':'',
'fcdfcaf296':'',
'fcdfcaf297':'',
'fcdfcaf298':'',
'fcdfcaf299':'',
'fcdfcaf300':'',
'fcdfcaf301':'',
'fcdfcaf302':'',
'fcdfcaf303':'',
'fcdfcaf304':'',
'fcdfcaf305':''

}

ncols = 4

Style = """
<STYLE TYPE="text/css">
  h2 { margin-left: +0%; color: #000000}
  h3 { margin-left: +0%; color: #228800}
  p { color: #000000 }
  blockquote { margin-left: +2%; color: #FF33333 }
  pre { color: #990033 }
</STYLE>
"""

def htmlHead(title='CDF CAF Admin Monitoring page', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print '<p><table border=0>'
    print '  <tr valign="center">'
    print '  <td width="100"  valign="center" halign="center">'
    print '    <a href="http://cdfcaf.fnal.gov/">'
    print '    <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '  <td valign="center" halign="center"><h1><font size=+10>'
    print '    CDF Central Analysis Facility<br></font></h1>'
    print '    <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '  </tr>'
    print '</table>'
    print    
    print '<hr>'
    print    

def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

def htmlBody():
    print '<body bgcolor="white">'
    print '<form method="get" action="/cgi-bin/caf/admin/graphs.py">'
    print    

    # Statistics
    print '<h2>Check the statistics to view</h2>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="stat" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    for i in range(len(stats)):
        statsList = stats[i+1]
        print '<td width="25%" valign="top"><font color="#990033">'
        print '  <input type="checkbox" name="stat%s" value="%s"> %s</a>' %\
              (i, statsList[0], statsList[1])
        
    print '<br>'
    print '</font></td>'
    print '</tr>'
    print '</table><p>'
    print '<hr>'
    print    
    print '<h2>Check the nodes to view above statistics on:</h2>'
    print    

    # Utility nodes
    print '<h3>Utility nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodeutil" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(utility_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(utility_nodes) / ncols) + 1
    for node in utility_nodes:
        i = utility_nodes.index(node)
        print '  <input type="checkbox" name="nodeutil%s" value="%s"> %s</a><br>' \
              % (i, node, node)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Servers
    print '<h3>Servers</h3>'
    print '<table border=0 width=515><tr>'

    # all, static and dCache buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodesrv" value="all">ALL </a>'
    print '  <input type="checkbox" name="nodesrv" value="dCache">dCache </a>'
    print '  <input type="checkbox" name="nodesrv" value="static1">Stage 1 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="static2">Stage 2 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="teststand">dCache test stand </a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="50%" valign="top"><font color="#990033">'
    ncols = 1
    irow = 0
    if len(servers) == ncols:
        nrows = 1
    else:
        nrows = int(len(servers) / ncols) + 1
    for node in servers:
        i = servers.index(node)
        if (node_description.has_key(node) and len(node_description[node]) > 0) : 
            description = ' - '+node_description[node]
        else:
            description = ''
        print '  <input type="checkbox" name="nodesrv%s" value="%s"> %s %s</a><br>' \
              % (i, node, node, description)
        irow = irow+1
        if irow == 16:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0
            
    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Worker nodes
    print '<h3>Worker nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all, Stage 1, and Stage 2 buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="node" value="all">ALL </a>'
    print '  <input type="checkbox" name="node" value="Stage1">Stage 1 </a>'
    print '  <input type="checkbox" name="node" value="Stage2">Stage 2 - all </a>'
    print '  <input type="checkbox" name="node" value="Stage2-static">Stage 2 - static</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 1
    if len(worker_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(worker_nodes) / ncols) + 1
    irow = 0
    for node in worker_nodes:
        i = worker_nodes.index(node)
        if (node_description.has_key(node) and len(node_description[node]) > 0) : 
            description = ' - '+node_description[node]
        else:
            description = ''
        print '  <input type="checkbox" name="node%s" value="%s"> %s %s</a><br>' \
              % (i, node, node, description)
        irow = irow+1
        if irow == 67:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print '<hr>'
    print    
    print '<br>'
    print '<input type="checkbox" name="optlog" value="1"> Log plots?</a>'
    print '</br>'
    print '<hr>'
    print    
    print '<input type="submit" value="Submit">'

    print '</form>'

if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()


