#!/usr/bin/python
import cgi
import commands
import os
import string

stats = {
    1:['load_average', 'Load averages'],
    2:['cpu','CPU usage'],
    3:['netxfer','Network throughput'],
    4:['memory','Memory usage']
    }

utility_nodes = {
    1:'fcdfhead1',
    2:'fcdfmon1',
    3:'fcdfcode1',
    4:'fcdflnx1',
    5:'fcdflnx2',
    6:'fcdflnx3'
    }

servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata007',  8:'fcdfdata008',
     9:'fcdfdata009', 10:'fcdfdata010', 11:'fcdfdata011', 12:'fcdfdata012',
    13:'fcdfdata013', 14:'fcdfdata014', 15:'fcdfdata015', 16:'fcdfdata016',
    17:'fcdfdata017', 18:'fcdfdata018', 19:'fcdfdata019', 20:'fcdfdata020',
    21:'fcdfdata021', 22:'fcdfdata022', 23:'fcdfdata023', 24:'fcdfdata024',
    25:'fcdfdata025', 26:'fcdfdata026', 27:'fcdfdata027', 28:'fcdfdata028',
    29:'fcdfdata029', 30:'fcdfdata030', 31:'fcdfdata031', 32:'fcdfdata032',
    33:'fcdfdata033', 34:'fcdfdata034', 35:'fcdfdata035', 36:'fcdfdata036',
    37:'fcdfdata037', 38:'fcdfdata038', 39:'fcdfdata039', 40:'fcdfdata040',
    41:'fcdfdata041', 42:'fcdfdata042', 43:'fcdfdata043', 44:'fcdfdata044',
    45:'fcdfdata045', 46:'fcdfdata046', 47:'fcdfdata047', 48:'fcdfdata048',
    49:'fcdfdata049', 50:'fcdfdata050', 51:'fcdfdata051', 52:'fcdfdata052',
    53:'fcdfdata053', 54:'fcdfdata054', 55:'fcdfdata055', 56:'fcdfdata056',
    57:'fcdfdata057', 58:'fcdfdata058', 59:'fcdfdata059', 60:'fcdfdata060',
    61:'fcdfdata061', 62:'fcdfdata062', 63:'fcdfdata063', 64:'fcdfdata064',
    65:'fcdfdata065', 66:'fcdfdata066', 67:'fcdfdata067', 68:'fcdfdata068',
    69:'fcdfdata069', 70:'fcdfdata070', 71:'fcdfdata071', 72:'fcdfdata072',
    73:'fcdfdata073', 74:'fcdfdata074', 75:'fcdfdata075', 76:'fcdfdata076',
    77:'fcdfdata077', 78:'fcdfdata078', 79:'fcdfdata079', 80:'fcdfdata080',
    81:'fcdfdata081', 82:'fcdfdata082', 83:'fcdfdata083', 84:'fcdfdata084',
    85:'fcdfdata085', 86:'fcdfdata086', 87:'fcdfdata087', 88:'fcdfdata088',
    89:'fcdfdata089', 90:'fcdfdata090', 91:'fcdfdata091'
    }

worker_nodes = {
     1:'fcdfcaf001',  2:'fcdfcaf002',  3:'fcdfcaf003',  4:'fcdfcaf004',
     5:'fcdfcaf005',  6:'fcdfcaf006',  7:'fcdfcaf007',  8:'fcdfcaf008',
     9:'fcdfcaf009', 10:'fcdfcaf010', 11:'fcdfcaf011', 12:'fcdfcaf012',
    13:'fcdfcaf013', 14:'fcdfcaf014', 15:'fcdfcaf015', 16:'fcdfcaf016',
    17:'fcdfcaf017', 18:'fcdfcaf018', 19:'fcdfcaf019', 20:'fcdfcaf020',
    21:'fcdfcaf021', 22:'fcdfcaf022', 23:'fcdfcaf023', 24:'fcdfcaf024',
    25:'fcdfcaf025', 26:'fcdfcaf026', 27:'fcdfcaf027', 28:'fcdfcaf028',
    29:'fcdfcaf029', 30:'fcdfcaf030', 31:'fcdfcaf031', 32:'fcdfcaf032',
    33:'fcdfcaf033', 34:'fcdfcaf034', 35:'fcdfcaf035', 36:'fcdfcaf036',
    37:'fcdfcaf037', 38:'fcdfcaf038', 39:'fcdfcaf039', 40:'fcdfcaf040',
    41:'fcdfcaf041', 42:'fcdfcaf042', 43:'fcdfcaf043', 44:'fcdfcaf044',
    45:'fcdfcaf045', 46:'fcdfcaf046', 47:'fcdfcaf047', 48:'fcdfcaf048',
    49:'fcdfcaf049', 50:'fcdfcaf050', 51:'fcdfcaf051', 52:'fcdfcaf052',
    53:'fcdfcaf053', 54:'fcdfcaf054', 55:'fcdfcaf055', 56:'fcdfcaf056',
    57:'fcdfcaf057', 58:'fcdfcaf058', 59:'fcdfcaf059', 60:'fcdfcaf060',
    61:'fcdfcaf061', 62:'fcdfcaf062', 63:'fcdfcaf063', 64:'fcdfcaf064',
    65:'fcdfcaf065', 66:'fcdfcaf066', 67:'fcdfcaf067'
    }

ncols = 4

Style = """
<STYLE TYPE="text/css">
  h2 { margin-left: +0%; color: #000000}
  h3 { margin-left: +0%; color: #228800}
  p { color: #000000 }
  blockquote { margin-left: +2%; color: #FF33333 }
  pre { color: #990033 }
</STYLE>
"""

def htmlHead(title='CDF CAF Admin Monitoring page', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print '<p><table border=0>'
    print '  <tr valign="center">'
    print '  <td width="100"  valign="center" halign="center">'
    print '    <a href="http://cdfcaf.fnal.gov/caf/">'
    print '    <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '  <td valign="center" halign="center"><h1><font size=+10>'
    print '    CDF Central Analysis Facility<br></font></h1>'
    print '    <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '  </tr>'
    print '</table>'
    print    
    print '<hr>'
    print    

def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

def htmlBody():
    print '<body bgcolor="white">'
    print '<form method="get" action="/cgi-bin/caf/admin/graphs.py">'
    print    

    # Statistics
    print '<h2>Check the statistics to view</h2>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="stat" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    for i in range(len(stats)):
        statsList = stats[i+1]
        print '<td width="25%" valign="top"><font color="#990033">'
        print '  <input type="checkbox" name="stat%s" value="%s"> %s</a>' %\
              (i, statsList[0], statsList[1])
        
    print '<br>'
    print '</font></td>'
    print '</tr>'
    print '</table><p>'
    print '<hr>'
    print    
    print '<h2>Check the nodes to view above statistics on:</h2>'
    print    

    # Utility nodes
    print '<h3>Utility nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodeutil" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(utility_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(utility_nodes) / ncols) + 1
    for i in range(len(utility_nodes)):
        un = utility_nodes[i+1]
        print '  <input type="checkbox" name="nodeutil%s" value="%s"> %s</a><br>' \
              % (i, un, un)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Servers
    print '<h3>Servers</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodesrv" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(servers) == ncols:
        nrows = 1
    else:
        nrows = int(len(servers) / ncols) + 1
#        nrows = int(len(servers) / ncols)
    for i in range(len(servers)):
        srv = servers[i+1]
        print '  <input type="checkbox" name="nodesrv%s" value="%s"> %s</a><br>' \
              % (i, srv, srv)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0
            
    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Worker nodes
    print '<h3>Worker nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="node" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    if len(worker_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(worker_nodes) / ncols) + 1
#    nrows = int(len(worker_nodes) / ncols)
    irow = 0
    for i in range(len(worker_nodes)):
        wn = worker_nodes[i+1]
        print '  <input type="checkbox" name="node%s" value="%s"> %s</a><br>' \
              % (i, wn, wn)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print '<hr>'
    print    
    print '<br>'
    print '<input type="checkbox" name="optlog" value="1"> Log plots?</a>'
    print '</br>'
    print '<hr>'
    print    
    print '<input type="submit" value="Submit">'

#    from time import localtime, time
#    (yr, mon, day, hr, min, sec, wkday, jday, dsf) = localtime(time())
#    print '<b>Start Date:</b>'
#    print '<input name="start_mon" size="2" value="'+str(mon)+'">'
#    print '<input name="start_day" size="2" value="'+str(day)+'">'
#    print '<input name="start_yr" size="4" value='+str(yr)+'">'
#    print '<b>Start Time:</b>'
#    print '<input name="start_hr" size="2" value="'+str(hr)+'">'
#    print '<input name="start_min" size="2" value="'+str(min)+'">'
#    print '<br>'
#    print 'Month(MM) Year(20YY)'

    print '</form>'

if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()


