#!/usr/bin/python
import cgi
import commands
import os
import string

stats = {
    1:['load_average', 'Load averages'],
    2:['cpu','CPU usage'],
    3:['netxfer','Network throughput'],
    4:['memory','Memory usage']
    }

utility_nodes = {
    1:'fcdfhead1',
    2:'fcdfhead2',
    3:'fcdfmon1',
    4:'fcdfcode1',
    5:'fcdflnx1',
    6:'fcdflnx2',
    7:'fcdflnx3'
    }

servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata007',  8:'fcdfdata008',
     9:'fcdfdata009', 10:'fcdfdata010', 11:'fcdfdata011', 12:'fcdfdata012',
    13:'fcdfdata013', 14:'fcdfdata014', 15:'fcdfdata015', 16:'fcdfdata016',
    17:'fcdfdata017', 18:'fcdfdata018', 19:'fcdfdata019', 20:'fcdfdata020',
    21:'fcdfdata021', 22:'fcdfdata022', 23:'fcdfdata023', 24:'fcdfdata024',
    25:'fcdfdata025', 26:'fcdfdata026', 27:'fcdfdata027', 28:'fcdfdata028',
    29:'fcdfdata029', 30:'fcdfdata030', 31:'fcdfdata031', 32:'fcdfdata032',
    33:'fcdfdata033', 34:'fcdfdata034', 35:'fcdfdata035', 36:'fcdfdata036',
    37:'fcdfdata037', 38:'fcdfdata038', 39:'fcdfdata039', 40:'fcdfdata040',
    41:'fcdfdata041', 42:'fcdfdata042', 43:'fcdfdata043', 44:'fcdfdata044',
    45:'fcdfdata045', 46:'fcdfdata046', 47:'fcdfdata047', 48:'fcdfdata048',
    49:'fcdfdata049', 50:'fcdfdata050', 51:'fcdfdata051', 52:'fcdfdata052',
    53:'fcdfdata053', 54:'fcdfdata054', 55:'fcdfdata055', 56:'fcdfdata056',
    57:'fcdfdata057', 58:'fcdfdata058', 59:'fcdfdata059', 60:'fcdfdata060',
    61:'fcdfdata061', 62:'fcdfdata062', 63:'fcdfdata063', 64:'fcdfdata064',
    65:'fcdfdata065', 66:'fcdfdata066', 67:'fcdfdata067', 68:'fcdfdata068',
    69:'fcdfdata069', 70:'fcdfdata070', 71:'fcdfdata071', 72:'fcdfdata072',
    73:'fcdfdata073', 74:'fcdfdata074', 75:'fcdfdata075', 76:'fcdfdata076',
    77:'fcdfdata077', 78:'fcdfdata078', 79:'fcdfdata079', 80:'fcdfdata080',
    81:'fcdfdata081', 82:'fcdfdata082', 83:'fcdfdata083', 84:'fcdfdata084',
    85:'fcdfdata085', 86:'fcdfdata086', 87:'fcdfdata087', 88:'fcdfdata088',
    89:'fcdfdata089', 90:'fcdfdata090', 91:'fcdfdata091'
    }

worker_nodes = {
      1:'fcdfcaf001',   2:'fcdfcaf002',   3:'fcdfcaf003',   4:'fcdfcaf004',
      5:'fcdfcaf005',   6:'fcdfcaf006',   7:'fcdfcaf007',   8:'fcdfcaf008',
      9:'fcdfcaf009',  10:'fcdfcaf010',  11:'fcdfcaf011',  12:'fcdfcaf012',
     13:'fcdfcaf013',  14:'fcdfcaf014',  15:'fcdfcaf015',  16:'fcdfcaf016',
     17:'fcdfcaf017',  18:'fcdfcaf018',  19:'fcdfcaf019',  20:'fcdfcaf020',
     21:'fcdfcaf021',  22:'fcdfcaf022',  23:'fcdfcaf023',  24:'fcdfcaf024',
     25:'fcdfcaf025',  26:'fcdfcaf026',  27:'fcdfcaf027',  28:'fcdfcaf028',
     29:'fcdfcaf029',  30:'fcdfcaf030',  31:'fcdfcaf031',  32:'fcdfcaf032',
     33:'fcdfcaf033',  34:'fcdfcaf034',  35:'fcdfcaf035',  36:'fcdfcaf036',
     37:'fcdfcaf037',  38:'fcdfcaf038',  39:'fcdfcaf039',  40:'fcdfcaf040',
     41:'fcdfcaf041',  42:'fcdfcaf042',  43:'fcdfcaf043',  44:'fcdfcaf044',
     45:'fcdfcaf045',  46:'fcdfcaf046',  47:'fcdfcaf047',  48:'fcdfcaf048',
     49:'fcdfcaf049',  50:'fcdfcaf050',  51:'fcdfcaf051',  52:'fcdfcaf052',
     53:'fcdfcaf053',  54:'fcdfcaf054',  55:'fcdfcaf055',  56:'fcdfcaf056',
     57:'fcdfcaf057',  58:'fcdfcaf058',  59:'fcdfcaf059',  60:'fcdfcaf060',
     61:'fcdfcaf061',  62:'fcdfcaf062',  63:'fcdfcaf063',  64:'fcdfcaf064',
     65:'fcdfcaf065',  66:'fcdfcaf066',  67:'fcdfcaf067',
     68:'fcdfcaf068',  69:'fcdfcaf069',  70:'fcdfcaf070',  71:'fcdfcaf071', 
     72:'fcdfcaf072',  73:'fcdfcaf073',  74:'fcdfcaf074',  75:'fcdfcaf075', 
     76:'fcdfcaf076',  77:'fcdfcaf077',  78:'fcdfcaf078',  79:'fcdfcaf079', 
     80:'fcdfcaf080',  81:'fcdfcaf081',  82:'fcdfcaf082',  83:'fcdfcaf083', 
     84:'fcdfcaf084',  85:'fcdfcaf085',  86:'fcdfcaf086',  87:'fcdfcaf087', 
     88:'fcdfcaf088',  89:'fcdfcaf089',  90:'fcdfcaf090',  91:'fcdfcaf091', 
     92:'fcdfcaf092',  93:'fcdfcaf093',  94:'fcdfcaf094',  95:'fcdfcaf095', 
     96:'fcdfcaf096',  97:'fcdfcaf097',  98:'fcdfcaf098',  99:'fcdfcaf099', 
    100:'fcdfcaf100', 101:'fcdfcaf101', 102:'fcdfcaf102', 103:'fcdfcaf103', 
    104:'fcdfcaf104', 105:'fcdfcaf105', 106:'fcdfcaf106', 107:'fcdfcaf107', 
    108:'fcdfcaf108', 109:'fcdfcaf109', 110:'fcdfcaf110', 111:'fcdfcaf111', 
    112:'fcdfcaf112', 113:'fcdfcaf113', 114:'fcdfcaf114', 115:'fcdfcaf115', 
    116:'fcdfcaf116', 117:'fcdfcaf117', 118:'fcdfcaf118', 119:'fcdfcaf119', 
    120:'fcdfcaf120', 121:'fcdfcaf121', 122:'fcdfcaf122', 123:'fcdfcaf123', 
    124:'fcdfcaf124', 125:'fcdfcaf125', 126:'fcdfcaf126', 127:'fcdfcaf127', 
    128:'fcdfcaf128', 129:'fcdfcaf129', 130:'fcdfcaf130', 131:'fcdfcaf131', 
    132:'fcdfcaf132', 133:'fcdfcaf133', 134:'fcdfcaf134', 135:'fcdfcaf135', 
    136:'fcdfcaf136', 137:'fcdfcaf137', 138:'fcdfcaf138', 139:'fcdfcaf139', 
    140:'fcdfcaf140', 141:'fcdfcaf141', 142:'fcdfcaf142', 143:'fcdfcaf143', 
    144:'fcdfcaf144', 145:'fcdfcaf145', 146:'fcdfcaf146', 147:'fcdfcaf147', 
    148:'fcdfcaf148', 149:'fcdfcaf149', 150:'fcdfcaf150', 151:'fcdfcaf151', 
    152:'fcdfcaf152', 153:'fcdfcaf153', 154:'fcdfcaf154', 155:'fcdfcaf155', 
    156:'fcdfcaf156', 157:'fcdfcaf157', 158:'fcdfcaf158', 159:'fcdfcaf159', 
    160:'fcdfcaf160', 161:'fcdfcaf161', 162:'fcdfcaf162', 163:'fcdfcaf163', 
    164:'fcdfcaf164', 165:'fcdfcaf165', 166:'fcdfcaf166', 167:'fcdfcaf167', 
    168:'fcdfcaf168', 169:'fcdfcaf169', 170:'fcdfcaf170', 171:'fcdfcaf171', 
    172:'fcdfcaf172', 173:'fcdfcaf173', 174:'fcdfcaf174', 175:'fcdfcaf175', 
    176:'fcdfcaf176', 177:'fcdfcaf177', 178:'fcdfcaf178', 179:'fcdfcaf179', 
    180:'fcdfcaf180', 181:'fcdfcaf181', 182:'fcdfcaf182', 183:'fcdfcaf183', 
    184:'fcdfcaf184', 185:'fcdfcaf185', 186:'fcdfcaf186', 187:'fcdfcaf187', 
    188:'fcdfcaf188', 189:'fcdfcaf189', 190:'fcdfcaf190', 191:'fcdfcaf191', 
    192:'fcdfcaf192', 193:'fcdfcaf193', 194:'fcdfcaf194', 195:'fcdfcaf195', 
    196:'fcdfcaf196', 197:'fcdfcaf197', 198:'fcdfcaf198', 199:'fcdfcaf199',
    200:'fcdfcaf200', 201:'fcdfcaf201', 202:'fcdfcaf202', 203:'fcdfcaf203',
    204:'fcdfcaf204', 205:'fcdfcaf205', 206:'fcdfcaf206', 207:'fcdfcaf207',
    208:'fcdfcaf208', 209:'fcdfcaf209', 210:'fcdfcaf210', 211:'fcdfcaf211',
    212:'fcdfcaf212', 213:'fcdfcaf213', 214:'fcdfcaf214', 215:'fcdfcaf215',
    216:'fcdfcaf216', 217:'fcdfcaf217', 218:'fcdfcaf218', 219:'fcdfcaf219',
    220:'fcdfcaf220', 221:'fcdfcaf221', 222:'fcdfcaf222', 223:'fcdfcaf223',
    224:'fcdfcaf224', 225:'fcdfcaf225', 226:'fcdfcaf226', 227:'fcdfcaf227',
    228:'fcdfcaf228', 229:'fcdfcaf229', 230:'fcdfcaf230', 231:'fcdfcaf231',
    232:'fcdfcaf232', 233:'fcdfcaf233', 234:'fcdfcaf234', 235:'fcdfcaf235',
    236:'fcdfcaf236', 237:'fcdfcaf237', 238:'fcdfcaf238', 239:'fcdfcaf239',
    240:'fcdfcaf240', 241:'fcdfcaf241', 242:'fcdfcaf242', 243:'fcdfcaf243',
    244:'fcdfcaf244', 245:'fcdfcaf245', 246:'fcdfcaf246', 247:'fcdfcaf247',
    248:'fcdfcaf248', 249:'fcdfcaf249', 250:'fcdfcaf250', 251:'fcdfcaf251',
    252:'fcdfcaf252', 253:'fcdfcaf253', 254:'fcdfcaf254', 255:'fcdfcaf255',
    256:'fcdfcaf256', 257:'fcdfcaf257', 258:'fcdfcaf258', 259:'fcdfcaf259',
    260:'fcdfcaf260', 261:'fcdfcaf261', 262:'fcdfcaf262', 263:'fcdfcaf263',
    264:'fcdfcaf264', 265:'fcdfcaf265', 266:'fcdfcaf266', 267:'fcdfcaf267',
    268:'fcdfcaf268', 269:'fcdfcaf269', 270:'fcdfcaf270', 271:'fcdfcaf271',
    272:'fcdfcaf272', 273:'fcdfcaf273', 274:'fcdfcaf274', 275:'fcdfcaf275',
    276:'fcdfcaf276', 277:'fcdfcaf277', 278:'fcdfcaf278', 279:'fcdfcaf279',
    280:'fcdfcaf280', 281:'fcdfcaf281', 282:'fcdfcaf282', 283:'fcdfcaf283',
    284:'fcdfcaf284', 285:'fcdfcaf285', 286:'fcdfcaf286', 287:'fcdfcaf287',
    288:'fcdfcaf288', 289:'fcdfcaf289', 290:'fcdfcaf290', 291:'fcdfcaf291',
    292:'fcdfcaf292', 293:'fcdfcaf293', 294:'fcdfcaf294', 295:'fcdfcaf295',
    296:'fcdfcaf296', 297:'fcdfcaf297', 298:'fcdfcaf298', 299:'fcdfcaf299',
    300:'fcdfcaf300', 301:'fcdfcaf301', 302:'fcdfcaf302', 303:'fcdfcaf303',
    304:'fcdfcaf304', 305:'fcdfcaf305', 306:'fcdfcaf306', 307:'fcdfcaf307',
    308:'fcdfcaf308', 309:'fcdfcaf309'
      }


stage1_worker_nodes = {
     1:'fcdfcaf001',  2:'fcdfcaf002',  3:'fcdfcaf003',  4:'fcdfcaf004',
     5:'fcdfcaf005',  6:'fcdfcaf006',  7:'fcdfcaf007',  8:'fcdfcaf008',
     9:'fcdfcaf009', 10:'fcdfcaf010', 11:'fcdfcaf011', 12:'fcdfcaf012',
    13:'fcdfcaf013', 14:'fcdfcaf014', 15:'fcdfcaf015', 16:'fcdfcaf016',
    17:'fcdfcaf017', 18:'fcdfcaf018', 19:'fcdfcaf019', 20:'fcdfcaf020',
    21:'fcdfcaf021', 22:'fcdfcaf022', 23:'fcdfcaf023', 24:'fcdfcaf024',
    25:'fcdfcaf025', 26:'fcdfcaf026', 27:'fcdfcaf027', 28:'fcdfcaf028',
    29:'fcdfcaf029', 30:'fcdfcaf030', 31:'fcdfcaf031', 32:'fcdfcaf032',
    33:'fcdfcaf033', 34:'fcdfcaf034', 35:'fcdfcaf035', 36:'fcdfcaf036',
    37:'fcdfcaf037', 38:'fcdfcaf038', 39:'fcdfcaf039', 40:'fcdfcaf040',
    41:'fcdfcaf041', 42:'fcdfcaf042', 43:'fcdfcaf043', 44:'fcdfcaf044',
    45:'fcdfcaf045', 46:'fcdfcaf046', 47:'fcdfcaf047', 48:'fcdfcaf048',
    49:'fcdfcaf049', 50:'fcdfcaf050', 51:'fcdfcaf051', 52:'fcdfcaf052',
    53:'fcdfcaf053', 54:'fcdfcaf054', 55:'fcdfcaf055', 56:'fcdfcaf056',
    57:'fcdfcaf057', 58:'fcdfcaf058', 59:'fcdfcaf059', 60:'fcdfcaf060',
    61:'fcdfcaf061', 62:'fcdfcaf062', 63:'fcdfcaf063', 64:'fcdfcaf064',
    65:'fcdfcaf065', 66:'fcdfcaf066', 67:'fcdfcaf067'
    }

stage2_worker_nodes = {
      1:'fcdfcaf068',   2:'fcdfcaf069',   3:'fcdfcaf070',   4:'fcdfcaf071', 
      5:'fcdfcaf072',   6:'fcdfcaf073',   7:'fcdfcaf074',   8:'fcdfcaf075', 
      9:'fcdfcaf076',  10:'fcdfcaf077',  11:'fcdfcaf078',  12:'fcdfcaf079', 
     13:'fcdfcaf080',  14:'fcdfcaf081',  15:'fcdfcaf082',  16:'fcdfcaf083', 
     17:'fcdfcaf084',  18:'fcdfcaf085',  19:'fcdfcaf086',  20:'fcdfcaf087', 
     21:'fcdfcaf088',  22:'fcdfcaf089',  23:'fcdfcaf090',  24:'fcdfcaf091', 
     25:'fcdfcaf092',  26:'fcdfcaf093',  27:'fcdfcaf094',  28:'fcdfcaf095', 
     29:'fcdfcaf096',  30:'fcdfcaf097',  31:'fcdfcaf098',  32:'fcdfcaf099', 
     33:'fcdfcaf100',  34:'fcdfcaf101',  35:'fcdfcaf102',  36:'fcdfcaf103', 
     37:'fcdfcaf104',  38:'fcdfcaf105',  39:'fcdfcaf106',  40:'fcdfcaf107', 
     41:'fcdfcaf108',  42:'fcdfcaf109',  43:'fcdfcaf110',  44:'fcdfcaf111', 
     45:'fcdfcaf112',  46:'fcdfcaf113',  47:'fcdfcaf114',  48:'fcdfcaf115', 
     49:'fcdfcaf116',  50:'fcdfcaf117',  51:'fcdfcaf118',  52:'fcdfcaf119', 
     53:'fcdfcaf120',  54:'fcdfcaf121',  55:'fcdfcaf122',  56:'fcdfcaf123', 
     57:'fcdfcaf124',  58:'fcdfcaf125',  59:'fcdfcaf126',  60:'fcdfcaf127', 
     61:'fcdfcaf128',  62:'fcdfcaf129',  63:'fcdfcaf130',  64:'fcdfcaf131', 
     65:'fcdfcaf132',  66:'fcdfcaf133',  67:'fcdfcaf134',  68:'fcdfcaf135', 
     69:'fcdfcaf136',  70:'fcdfcaf137',  71:'fcdfcaf138',  72:'fcdfcaf139', 
     73:'fcdfcaf140',  74:'fcdfcaf141',  75:'fcdfcaf142',  76:'fcdfcaf143', 
     77:'fcdfcaf144',  78:'fcdfcaf145',  79:'fcdfcaf146',  80:'fcdfcaf147', 
     81:'fcdfcaf148',  82:'fcdfcaf149',  83:'fcdfcaf150',  84:'fcdfcaf151', 
     85:'fcdfcaf152',  86:'fcdfcaf153',  87:'fcdfcaf154',  88:'fcdfcaf155', 
     89:'fcdfcaf156',  90:'fcdfcaf157',  91:'fcdfcaf158',  92:'fcdfcaf159', 
     93:'fcdfcaf160',  94:'fcdfcaf161',  95:'fcdfcaf162',  96:'fcdfcaf163', 
     97:'fcdfcaf164',  98:'fcdfcaf165',  99:'fcdfcaf166', 100:'fcdfcaf167', 
    101:'fcdfcaf168', 102:'fcdfcaf169', 103:'fcdfcaf170', 104:'fcdfcaf171', 
    105:'fcdfcaf172', 106:'fcdfcaf173', 107:'fcdfcaf174', 108:'fcdfcaf175', 
    109:'fcdfcaf176', 110:'fcdfcaf177', 111:'fcdfcaf178', 112:'fcdfcaf179', 
    113:'fcdfcaf180', 114:'fcdfcaf181', 115:'fcdfcaf182', 116:'fcdfcaf183', 
    117:'fcdfcaf184', 118:'fcdfcaf185', 119:'fcdfcaf186', 120:'fcdfcaf187', 
    121:'fcdfcaf188', 122:'fcdfcaf189', 123:'fcdfcaf190', 124:'fcdfcaf191', 
    125:'fcdfcaf192', 126:'fcdfcaf193', 127:'fcdfcaf194', 128:'fcdfcaf195', 
    129:'fcdfcaf196', 130:'fcdfcaf197', 131:'fcdfcaf198', 132:'fcdfcaf199',
    133:'fcdfcaf200', 134:'fcdfcaf201', 135:'fcdfcaf202', 136:'fcdfcaf203',
    137:'fcdfcaf204', 138:'fcdfcaf205', 139:'fcdfcaf206', 130:'fcdfcaf207',
    141:'fcdfcaf208', 142:'fcdfcaf209', 143:'fcdfcaf210', 144:'fcdfcaf211',
    145:'fcdfcaf212', 146:'fcdfcaf213', 147:'fcdfcaf214', 148:'fcdfcaf215',
    149:'fcdfcaf216', 150:'fcdfcaf217', 151:'fcdfcaf218', 152:'fcdfcaf219',
    153:'fcdfcaf220', 154:'fcdfcaf221', 155:'fcdfcaf222', 156:'fcdfcaf223',
    157:'fcdfcaf224', 158:'fcdfcaf225', 159:'fcdfcaf226', 160:'fcdfcaf227',
    161:'fcdfcaf228', 162:'fcdfcaf229', 163:'fcdfcaf230', 164:'fcdfcaf231',
    165:'fcdfcaf232', 166:'fcdfcaf233', 167:'fcdfcaf234', 168:'fcdfcaf235',
    169:'fcdfcaf236', 170:'fcdfcaf237', 171:'fcdfcaf238', 172:'fcdfcaf239',
    173:'fcdfcaf240', 174:'fcdfcaf241', 175:'fcdfcaf242', 176:'fcdfcaf243',
    177:'fcdfcaf244', 178:'fcdfcaf245', 179:'fcdfcaf246', 180:'fcdfcaf247',
    181:'fcdfcaf248', 182:'fcdfcaf249', 183:'fcdfcaf250', 184:'fcdfcaf251',
    185:'fcdfcaf252', 186:'fcdfcaf253', 187:'fcdfcaf254', 188:'fcdfcaf255',
    189:'fcdfcaf256', 190:'fcdfcaf257', 191:'fcdfcaf258', 192:'fcdfcaf259',
    193:'fcdfcaf260', 194:'fcdfcaf261', 195:'fcdfcaf262', 196:'fcdfcaf263',
    197:'fcdfcaf264', 198:'fcdfcaf265', 199:'fcdfcaf266', 200:'fcdfcaf267',
    201:'fcdfcaf268', 202:'fcdfcaf269', 203:'fcdfcaf270', 204:'fcdfcaf271',
    205:'fcdfcaf272', 206:'fcdfcaf273', 207:'fcdfcaf274', 208:'fcdfcaf275',
    209:'fcdfcaf276', 210:'fcdfcaf277', 211:'fcdfcaf278', 212:'fcdfcaf279',
    213:'fcdfcaf280', 214:'fcdfcaf281', 215:'fcdfcaf282', 216:'fcdfcaf283',
    217:'fcdfcaf284', 218:'fcdfcaf285', 219:'fcdfcaf286', 220:'fcdfcaf287',
    221:'fcdfcaf288', 222:'fcdfcaf289', 223:'fcdfcaf290', 224:'fcdfcaf291',
    225:'fcdfcaf292', 226:'fcdfcaf293', 227:'fcdfcaf294', 228:'fcdfcaf295',
    229:'fcdfcaf296', 230:'fcdfcaf297', 231:'fcdfcaf298', 232:'fcdfcaf299',
    233:'fcdfcaf300', 234:'fcdfcaf301', 235:'fcdfcaf302', 236:'fcdfcaf303',
    237:'fcdfcaf304', 238:'fcdfcaf305', 239:'fcdfcaf306', 240:'fcdfcaf307',
    241:'fcdfcaf308', 242:'fcdfcaf309'
      }

ncols = 4

Style = """
<STYLE TYPE="text/css">
  h2 { margin-left: +0%; color: #000000}
  h3 { margin-left: +0%; color: #228800}
  p { color: #000000 }
  blockquote { margin-left: +2%; color: #FF33333 }
  pre { color: #990033 }
</STYLE>
"""

def htmlHead(title='CDF CAF Admin Monitoring page', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print '<p><table border=0>'
    print '  <tr valign="center">'
    print '  <td width="100"  valign="center" halign="center">'
    print '    <a href="http://cdfcaf.fnal.gov/">'
    print '    <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '  <td valign="center" halign="center"><h1><font size=+10>'
    print '    CDF Central Analysis Facility<br></font></h1>'
    print '    <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '  </tr>'
    print '</table>'
    print    
    print '<hr>'
    print    

def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

def htmlBody():
    print '<body bgcolor="white">'
    print '<form method="get" action="/cgi-bin/caf/admin/graphs.py">'
    print    

    # Statistics
    print '<h2>Check the statistics to view</h2>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="stat" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    for i in range(len(stats)):
        statsList = stats[i+1]
        print '<td width="25%" valign="top"><font color="#990033">'
        print '  <input type="checkbox" name="stat%s" value="%s"> %s</a>' %\
              (i, statsList[0], statsList[1])
        
    print '<br>'
    print '</font></td>'
    print '</tr>'
    print '</table><p>'
    print '<hr>'
    print    
    print '<h2>Check the nodes to view above statistics on:</h2>'
    print    

    # Utility nodes
    print '<h3>Utility nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodeutil" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(utility_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(utility_nodes) / ncols) + 1
    for i in range(len(utility_nodes)):
        un = utility_nodes[i+1]
        print '  <input type="checkbox" name="nodeutil%s" value="%s"> %s</a><br>' \
              % (i, un, un)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Servers
    print '<h3>Servers</h3>'
    print '<table border=0 width=515><tr>'

    # all, static and dCache buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodesrv" value="all">ALL </a>'
    print '  <input type="checkbox" name="nodesrv" value="dCache">dCache </a>'
    print '  <input type="checkbox" name="nodesrv" value="static">static </a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(servers) == ncols:
        nrows = 1
    else:
        nrows = int(len(servers) / ncols) + 1
    for i in range(len(servers)):
        srv = servers[i+1]
        print '  <input type="checkbox" name="nodesrv%s" value="%s"> %s</a><br>' \
              % (i, srv, srv)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0
            
    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Worker nodes
    print '<h3>Worker nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all, Stage 1, and Stage 2 buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="node" value="all">ALL </a>'
    print '  <input type="checkbox" name="node" value="Stage1">Stage 1 </a>'
    print '  <input type="checkbox" name="node" value="Stage2">Stage 2 </a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    if len(worker_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(worker_nodes) / ncols) + 1
#    nrows = int(len(worker_nodes) / ncols)
    irow = 0
    for i in range(len(worker_nodes)):
        wn = worker_nodes[i+1]
        print '  <input type="checkbox" name="node%s" value="%s"> %s</a><br>' \
              % (i, wn, wn)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print '<hr>'
    print    
    print '<br>'
    print '<input type="checkbox" name="optlog" value="1"> Log plots?</a>'
    print '</br>'
    print '<hr>'
    print    
    print '<input type="submit" value="Submit">'

#    from time import localtime, time
#    (yr, mon, day, hr, min, sec, wkday, jday, dsf) = localtime(time())
#    print '<b>Start Date:</b>'
#    print '<input name="start_mon" size="2" value="'+str(mon)+'">'
#    print '<input name="start_day" size="2" value="'+str(day)+'">'
#    print '<input name="start_yr" size="4" value='+str(yr)+'">'
#    print '<b>Start Time:</b>'
#    print '<input name="start_hr" size="2" value="'+str(hr)+'">'
#    print '<input name="start_min" size="2" value="'+str(min)+'">'
#    print '<br>'
#    print 'Month(MM) Year(20YY)'

    print '</form>'

if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()


