#!/usr/bin/python
import cgi
import os
import time
import sys
import stat
import string

#print 'Content-type: text/html\nCache-Control: No-cache\n\n'

cgiEnv = cgi.FieldStorage()
GraphRoot = 'graphs'

if not cgiEnv.has_key('graph'):
	sys.exit(1)

graph = cgiEnv['graph'].value
fn = '%s/%s' % (GraphRoot, graph)
FFN = '%s/%s.%s' % (GraphRoot, graph,"NEW")
typ = string.split(graph, '.')[-1]
#print '\n'+graph
#print '\n'+fn


st = os.stat(fn)
mt = st[stat.ST_MTIME]
et = mt + 120
gmt = time.gmtime(mt)
tstr = time.asctime(gmt)

mime_type = 'application/octet-stream'
if typ == 'gif':
	mime_type = 'image/gif'
elif typ == 'png':
	mime_type = 'image/png'
elif typ == 'jpg' or typ == 'jpeg':
	mime_type = 'image/jpeg'
	
print 'Last-modified: %s GMT' % tstr
print 'Expires: %s GMT' % time.asctime(time.gmtime(et))
print 'Content-type: %s' % mime_type
print ''
f = open(fn, 'r')
eof = 0
while not eof:
	data = f.read(100000)
	if data:
		try:	sys.stdout.write(data)
		except: eof = 1
	else:
		eof = 1
sys.exit(0)

